/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#include "buttonbar.h"
#include "entrypop.h"
#include "memory.h"
#include "callback.h"
#include "param.h"

#include "newfile.xpm"
#include "openfile.xpm"
#include "savefile.xpm"
#include "separ.xpm"
#include "printfile.xpm"
#include "cut.xpm"
#include "copy.xpm"
#include "paste.xpm"
#include "brush.xpm"
#include "undo.xpm"
#include "do.xpm"
#include "sum.xpm"
#include "formula.xpm"
#include "sorta.xpm"
#include "sortd.xpm"
#include "plot.xpm"

static Entry_Pop *pop;

void
newzmvalue (widget, pointer, junk)
     Widget widget;
     XtPointer pointer;
     XtPointer junk;
{
  int zm;
  sscanf (pointer, "%d", &zm);
  cb_setzm (zm);
}

void
updatezm (int z)
{
  char label[10];
  sprintf (label, "%d%%", z);
  entrypop_set_val (pop, label);
  cb_setzm (z);
}

void
setzmlabel (int z)
{
  char label[10];
  sprintf (label, "%d%%", z);
  entrypop_set_val (pop, label);
}

static struct buttonEntry ButtonLineEntries[] =
{
  {"newFile", newfile_xpm, m_nfile},
  {"openFile", openfile_xpm, X11m_ofile},
  {"saveFile", savefile_xpm, X11m_sfile},
  {"separ", separ_xpm, NULL},
  {"printFile", printfile_xpm, X11m_print},
  {"separ", separ_xpm, NULL},
  {"cut", cut_xpm, mcut},
  {"copy", copy_xpm, mcpy},
  {"paste", paste_xpm, mpst},
  {"brush", brush_xpm, mbrsh},
  {"separ", separ_xpm, NULL},
  {"undo", undo_xpm, NULL},
  {"do", do_xpm, NULL},
  {"separ", separ_xpm, NULL},
  {"sum", sum_xpm, m_sum},
  {"formula", formula_xpm, X11m_formula},
  {"sorta", sorta_xpm, m_sorta},
  {"sortd", sortd_xpm, m_sortd},
  {"separ", separ_xpm, NULL},
  {"plot", plot_xpm, m_creaplt},
  {"separ", separ_xpm, NULL}
};

Buttonbar *
newbuttonbar (buttonbar)
     Widget buttonbar;
{
  int i;
  Buttonbar *bb_obj;
  bb_obj = (Buttonbar *) absmalloc (sizeof (Buttonbar), "newbuttonbar:bb_obj ");
  for (i = 0; i < XtNumber (ButtonLineEntries); i++)
    make_button_pixmap (buttonbar,
			ButtonLineEntries[i].name,
			ButtonLineEntries[i].pixmapname,
			ButtonLineEntries[i].function, NULL);

  pop = newentrypop (buttonbar, "zmlist");
  entrypop_callback (pop, newzmvalue);
  entrypop_add_item (pop, "200%");
  entrypop_add_item (pop, "100%");
  entrypop_add_item (pop, "75%");
  entrypop_add_item (pop, "50%");
  entrypop_add_item (pop, "25%");
  entrypop_init_val (pop, "100%");

  return bb_obj;
}
