/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#include "callback.h"
#include "callback_decl.h"
#include "inputbox.h"
#include "gr_interf.h"
#include "main.h"

#include "cursor.h"
#include "application.h"

extern void setscrollv (double v);
extern void setscrollh (double v);

#include "newplot.h"

extern int rebuild_thumb ();

#define AW ActiveWorksheet

static Cell *HighCell = NULL;

int
DoUndoFormula (int r, int c, char *formula)
{

  return 0;
}

int
cbcgsht (int sheet)
{

  if (applicationcgsht (sheet))
    return -1;

  return 0;
}

int
repaint_activesheet ()
{
  flag2 = 0;
  flag3 = 0;
  isselectingbtn = 0;
  rstsel (0, 0, 0);
  xrepnt ();
  return 0;
}

int
selectingto0 ()
{
  flag2 = 0;
  flag3 = 0;
  isselectingbtn = 0;
  return 0;
}

void
a_update ()
{

  if (flag4 && flag5)
    {
      DoUndoFormula (ty, tx, getstring (Letxt));
      set_formula (ty, tx, getstring (Letxt));

    }

  if (flag4)
    {
      xdrawcell (ty, tx, 6);
      setstring (Letxt, "");
      XtSetSensitive (Letxt, False);
      XtSetKeyboardFocus (toplevel, draw);
      XawTextDisplayCaret (Letxt, False);
      flag4 = 0;
      flag5 = 0;
      rstsel (0, 0, 0);
    }
  return;

}

void
echfct (char *buf)
{
  insstr (Letxt, buf);
  mvinspt (Letxt, -1);
  if (HighCell == ActiveCell)
    xdrawcell2 (ActiveCell, 3);
}

void
cbtup (Widget w, XEvent * event, String * params, int *num_params)
{
  a_update ();
  flechi--;
  if (flechi < 1)
    flechi = 1;
  flechmove = 1;
  cbdb1up (draw, event, params, num_params);
}

void
cbtdown (Widget w, XEvent * event, String * params, int *num_params)
{
  a_update ();
  flechi++;
  if (flechj > AW->nlin)
    flechj = AW->nlin;
  flechmove = 1;
  cbdb1up (draw, event, params, num_params);
}

void
cbtleft (Widget w, XEvent * event, String * params, int *num_params)
{
  long p;

  p = XawTextGetInsertionPoint (Letxt);
  if (p > 0)
    {
      p--;
      XawTextSetInsertionPoint (Letxt, p);
      return;
    }

  left = 1;
  a_update ();
  flechj--;
  if (flechj < 1)
    flechj = 1;
  flechmove = 1;
  cbdb1up (draw, event, params, num_params);
}

void
cbtright (Widget w, XEvent * event, String * params, int *num_params)
{
  long p;
  int l;

  l = strlen (getstring (Letxt));
  p = XawTextGetInsertionPoint (Letxt);
  if (p < l)
    {
      p++;
      XawTextSetInsertionPoint (Letxt, p);
      return;
    }

  a_update ();
  flechj++;
  if (flechj > AW->ncol)
    flechj = AW->ncol;
  flechmove = 1;
  cbdb1up (draw, event, params, num_params);
}

void
cbdel (Widget w, XEvent * event, String * params, int *num_params)
{
  long p;
  int l, i;
  char *str;
  char tmp[256];
  Widget t;

  if (flag4)
    t = Letxt;
  else
    t = w;

  str = getstring (t);
  if (str == NULL)
    return;
  strcpy (tmp, str);

  l = strlen (str);
  p = XawTextGetInsertionPoint (t);
  if (p == l)
    return;

  for (i = p; i < l - 1; i++)
    tmp[i] = tmp[i + 1];
  tmp[l - 1] = '\0';

  setstring (t, tmp);
  XawTextSetInsertionPoint (t, p);
  return;
}

void
cbbak (Widget w, XEvent * event, String * params, int *num_params)
{
  long p;
  int l, i;
  char *str;
  char tmp[256];
  Widget t;

  if (flag4)
    t = Letxt;
  else
    t = w;

  str = getstring (t);
  if (str == NULL)
    return;
  strcpy (tmp, str);

  l = strlen (str);
  p = XawTextGetInsertionPoint (t);
  if (p == 0)
    return;

  for (i = p - 1; i < l - 1; i++)
    tmp[i] = tmp[i + 1];

  tmp[l - 1] = '\0';
  setstring (t, tmp);
  XawTextSetInsertionPoint (t, p - 1);
  return;
}

void
cbdmv (Widget w, XEvent * event, String * params, int *num_params)
{

  Drawing *dr;
  int x, y;
  int xmin, xmax, ymin, ymax;
  int i1, i2, j1, j2, k;

  if (FLAG1 != VAL36)
    return;
  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  if (drawingmode)
    {

      mvx = x;
      mvy = y;
      absmvx = mvx + AW->cw[AW->cc];
      absmvy = mvy + AW->lh[AW->ll];

      if (drawingmode == VAL41)
	{
	  for (k = 0; k < getndr (); k++)
	    {
	      dr = (Drawing *) getdr (k);
	      if (drawing_pnt (dr, absmvx, absmvy, 5, 5) && ActiveDrawing != dr)
		{
		  ActivateDrawing (dr);
		  clearnflush ();
		  drawselect ();
		}
	    }
	}
      return;
    }

  if (is_selecting ())
    {
      get_select (&i1, &j1, &i2, &j2);

      ijtoxy (i1, j1, &xmin, &ymin);
      ijtoxy (i2 + 1, j2 + 1, &xmax, &ymax);
      if (xmin < x && x < xmax && ymin - 10 < y && y < ymin + 10)
	{
	  if (VAL1 != VAL3 && VAL1 != VAL35)
	    {
	      tohand (draw);
	      VAL1 = VAL3;
	    }
	}
      else if (xmax - 5 < x && x < xmax + 5 && ymax - 5 < y && y < ymax + 5)
	{
	  if (VAL1 != VAL21 && VAL1 != VAL35)
	    {
	      tobotrig (draw);
	      VAL1 = VAL21;
	    }
	}
      else if (VAL1 == VAL3 || VAL1 == VAL21)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
    }

  if (flag2)
    {
      if (xa - 4 <= x && x <= xa + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL4)
	    TurnOnBottomLeft (draw);
	  VAL1 = VAL4;
	}
      else if (VAL1 == VAL4)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL5)
	    tobotrig (draw);
	  VAL1 = VAL5;
	}
      else if (VAL1 == VAL5)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if (xa - 4 <= x && x <= xa + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL15)
	    totopleft (draw);
	  VAL1 = VAL15;
	}
      else if (VAL1 == VAL15)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL7)
	    totrig (draw);
	  VAL1 = VAL7;
	}
      else if (VAL1 == VAL7)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if ((xa + xb) / 2 - 4 <= x && x <= (xa + xb) / 2 + 4 && yb - 4 <= y && y <= yb + 4)
	{
	  if (VAL1 != VAL6)
	    tobsd (draw);
	  VAL1 = VAL6;
	}
      else if (VAL1 == VAL6)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if (xb - 4 <= x && x <= xb + 4 && (yb + ya) / 2 - 4 <= y && y <= (yb + ya) / 2 + 4)
	{
	  if (VAL1 != VAL17)
	    TurnOnRightSide (draw);
	  VAL1 = VAL17;
	}
      else if (VAL1 == VAL17)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if ((xa + xb) / 2 - 4 <= x && x <= (xa + xb) / 2 + 4 && ya - 4 <= y && y <= ya + 4)
	{
	  if (VAL1 != VAL18)
	    TurnOnTopSide (draw);
	  VAL1 = VAL18;
	}
      else if (VAL1 == VAL18)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
      if (xa - 4 <= x && x <= xa + 4 && (yb + ya) / 2 - 4 <= y && y <= (yb + ya) / 2 + 4)
	{
	  if (VAL1 != VAL16)
	    TurnOnLeftSide (draw);
	  VAL1 = VAL16;
	}
      else if (VAL1 == VAL16)
	{
	  toffcur (draw);
	  VAL1 = VAL2;
	}
    }
  if (w == colind)
    {
      tohand (colind);
    }
  if (w == linind)
    {
      tohand (linind);
    }
}

void
cbdn2down (Widget w, XEvent * event, String * params, int *num_params)
{
  dwnx = event->xbutton.x * 100 / zm;
  dwny = event->xbutton.y * 100 / zm;

}

void
cbdbt2mv (Widget w, XEvent * event, String * params, int *num_params)
{
  int i0, j0, i1, j1;

  mvx = event->xbutton.x * 100 / zm;
  mvy = event->xbutton.y * 100 / zm;

  if (mvx != dwnx || mvy != dwny)
    {
      xytoij (dwnx, dwny, &i0, &j0);
      xytoij (mvx, mvy, &i1, &j1);
      i0 = AW->ll - (i1 - i0);
      j0 = AW->cc - (j1 - j0);
      if (i0 < 1)
	i0 = 1;
      if (j0 < 1)
	j0 = 1;
      cbrepnt (i0, j0, Width, Height);
    }

  dwnx = mvx;
  dwny = mvy;

}

void
cbdb2up (Widget w, XEvent * event, String * params, int *num_params)
{
  int i0, j0, i1, j1;

  upx = event->xbutton.x * 100 / zm;
  upy = event->xbutton.y * 100 / zm;

  if (upx != dwnx || upy != dwny)
    {
      xytoij (dwnx, dwny, &i0, &j0);
      xytoij (upx, upy, &i1, &j1);
      i0 = AW->ll - (i1 - i0);
      j0 = AW->cc - (j1 - j0);

      if (i0 < 1)
	i0 = 1;
      if (j0 < 1)
	j0 = 1;
      cbrepnt (i0, j0, Width, Height);
    }

}

void
cb_PageHome (Widget w, XEvent * event, String * params, int *num_params)
{

  cbrepnt (1, 1, Width, Height);
}

void
cbpgup (Widget w, XEvent * event, String * params, int *num_params)
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cells (&i1, &j1, &i2, &j2);
  h = i2 - i1;
  i1 -= h + 2;
  if (i1 < 1)
    i1 = 1;
  cbrepnt (i1, -1, Width, Height);
}

void
cbpgdwn (Widget w, XEvent * event, String * params, int *num_params)
{
  int i1, j1, i2, j2;
  getvisi_cells (&i1, &j1, &i2, &j2);
  cbrepnt (i2 - 2, -1, Width, Height);
}

void
cbpgleft (Widget w, XEvent * event, String * params, int *num_params)
{
  int i1, j1, i2, j2;
  int h;
  getvisi_cells (&i1, &j1, &i2, &j2);
  h = j2 - j1;
  j1 -= h + 2;
  if (j1 < 1)
    j1 = 1;

  cbrepnt (-1, j1, Width, Height);
}

void
cbpgrig (Widget w, XEvent * event, String * params, int *num_params)
{
  int i1, j1, i2, j2;
  getvisi_cells (&i1, &j1, &i2, &j2);

  cbrepnt (-1, j2 - 2, Width, Height);
}

void
cbdb1up (Widget w, XEvent * event, String * params, int *num_params)
{
  Arg args[5];
  register int n;
  char *label;
  char buf[16];
  char buf1[16];
  int x, y;
  int i, j;
  Graph *gr;
  Button *btn;

  if (!flechmove)
    {
      x = event->xbutton.x * 100 / zm;
      y = event->xbutton.y * 100 / zm;
      upx = x;
      upy = y;
      aupx = upx + AW->cw[AW->cc];
      aupy = upy + AW->lh[AW->ll];

      xytoij (x, y, &i, &j);
      upi = i;
      upj = j;
    }

  if (drawingmode)
    {
      if (drawingmode == VAL42)
	{
	  drawingmode = VAL41;
	  TurnOnPencil (draw);
	  FLAG1 = VAL36;
	  xrepnt ();
	  return;
	}

      if (drawingmode == VAL39)
	{
	  drawingmode = 0;
	  FLAG1 = VAL36;
	  drplt ();
	  return;
	}
      drawingmode = VAL41;
      TurnOnPencil (draw);
      FLAG1 = VAL36;
      return;
    }

  switch (FLAG2)
    {
    case CB_BUTTON:
      {

	btn = (Button *) getbtn (isselectingbtn - 1);

	if (upx > btn->x1 - AW->cw[AW->cc] && upy > btn->y1 - AW->lh[AW->ll] &&
	    upx < btn->x2 - AW->cw[AW->cc] && upy < btn->y2 - AW->lh[AW->ll]
	  )
	  {
	    button_click (btn);
	  }

	redrawbt (btn);
	cpypix ();
	FLAG1 = VAL36;
	return;
      }
    case VAL30:
      {
	VAL1 = VAL2;
	toffcur (draw);
	FLAG1 = VAL36;
	drplt ();
	break;
      }
    case VAL10:
      {
	if (VAL1 == VAL14)
	  {
	    VAL1 = VAL2;
	    toffcur (draw);
	    gr = (Graph *) getlastgra ();
	    gr->x = grx;
	    gr->y = gry;
	    gr->h = grh;
	    gr->w = grw;
	    plot ();
	    xrepnt ();
	  }
	if (VAL1 == VAL4 ||
	    VAL1 == VAL5 ||
	    VAL1 == VAL7 ||
	    VAL1 == VAL18 ||
	    VAL1 == VAL17 ||
	    VAL1 == VAL6 ||
	    VAL1 == VAL16 ||
	    VAL1 == VAL15)
	  {
	    VAL1 = VAL2;
	    toffcur (draw);
	    gr = (Graph *) getlastgra ();
	    gr->x = grx;
	    gr->y = gry;
	    gr->h = grh;
	    gr->w = grw;
	    resizegra ();
	    plot ();
	    xrepnt ();
	  }
	break;
      }
    case VAL11X:
      {
	if (FLAG1 == VAL20)
	  {
	    selectlin (i);
	    li = 0;
	    cj = 0;
	    break;
	  }
	else
	  {
	    xrepnt ();
	    cj = 0;
	    li = 0;
	    break;
	  }
      }
    case VAL12:
      {
	if (FLAG1 == VAL20)
	  {
	    selectcol (j);
	    li = 0;
	    cj = 0;
	    break;
	  }
	else
	  {
	    xrepnt ();
	    cj = 0;
	    li = 0;
	    break;
	  }
      }
    case VAL43:
      {
	if (FLAG1 == VAL20)
	  {
	    selectall ();
	    li = 0;
	    cj = 0;
	    break;
	  }
	else
	  {
	    xrepnt ();
	    cj = 0;
	    li = 0;
	    break;
	  }
      }
    case VAL13:
      {
	n2a (buf, dwni, dwnj);
	if (VAL44 == Letxt)
	  insstr (Letxt, buf);
	else
	  {
	    if (VAL45 != NULL)
	      XtManageChild (VAL45);
	    setstring (VAL44, buf);
	  }

	if (dwni != i || dwnj != j)
	  {
	    n2a (buf1, i, j);

	    if (VAL44 != Letxt)
	      {
		sprintf (buf, "%s:%s", buf, buf1);
		setstring (VAL44, buf);
	      }
	    else
	      {
		sprintf (buf, ":%s", buf1);
		insstr (Letxt, buf);
	      }
	  }
	VAL44 = Letxt;
	rstsel (dwni, dwnj, 1);
	FLAG2 = VAL22;
	FLAG1 = VAL36;

	break;
      }
    case VAL19:
      {
	TurnOffMove (draw);
	VAL1 = VAL2;
	if (dwni - i || dwnj - j)
	  {
	    mvsel (dwni, dwnj, i, j, 1);

	    upi += i - dwni;
	    upj += j - dwnj;
	    dwni = i;
	    dwnj = j;
	    break;
	  }
	else
	  {
	    rstsel (dwni, dwnj, 1);
	    FLAG2 = VAL22;
	  }

      }
    default:
      {

	if (flechmove)
	  {
	    i = flechi;
	    j = flechj;

	  }
	if (!flechmove)
	  {
	    flechi = i;
	    flechj = j;
	  }
	ijtoxy (i, j, &x, &y);
	if (is_selecting ())
	  {
	    makebrush ();
	    toffcur (draw);
	    VAL1 = VAL2;
	    break;
	  }
	if (w == draw)
	  {
	    n = 0;
	    XtSetArg (args[n], XtNx, x);
	    n++;
	    XtSetArg (args[n], XtNy, y);
	    n++;
	    label = (char *) get_formula (i, j);
	    if (label != NULL)
	      setstring (Letxt, label);
	    else
	      setstring (Letxt, "");

	    left = 0;
	    setvisi (i, j);
	    if (is_selecting () || flag2 || flag3)
	      {
		rstsel (0, 0, 0);
		flag2 = 0;
		flag3 = 0;
		isselectingbtn = 0;
		xrepnt ();
	      }
	    ActiveCell = (Cell *) applicationcell (i, j, 1);
	    xdrawcell (i, j, 2);
	    tx = j;
	    ty = i;
	    XtSetSensitive (Letxt, True);
	    XtSetKeyboardFocus (toplevel, Letxt);
	    XawTextDisplayCaret (Letxt, True);
	    flag4 = 1;
	    flag5 = 0;
	  }
      }
    }
  FLAG1 = VAL36;
  FLAG2 = 0;
  FLAG4 = 0;

}

void
cb_TextChange ()

{
  if (flag4 && !flechmove)
    {
      flag5 = 1;
      xdrawcell (ty, tx, 3);
    }
  flechmove = 0;
}

void
cb_TextReturn (Widget w, XEvent * event, String * params, int *num_params)
{
  a_update ();
}

void
cb_BtnOk ()
{

  a_update ();
}

void
cb_BtnCancel ()
{
  if (flag4)
    {
      xdrawcell (ty, tx, 6);
      setstring (Letxt, "");
      XtSetSensitive (Letxt, False);
      XawTextDisplayCaret (Letxt, False);
      flag4 = 0;
      rstsel (0, 0, 0);
      return;
    }
}

void
cb_DocBtn1Motion (Widget w, XEvent * event, String * params, int *num_params)
{
  int i, j;
  int x, y;
  int dx, dy;
  Drawing *dr;

  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  mvx = x;
  mvy = y;
  absmvx = mvx + AW->cw[AW->cc];
  absmvy = mvy + AW->lh[AW->ll];
  xytoij (x, y, &i, &j);
  movei = i;
  movej = j;

  if (drawingmode)
    {
      if (drawingmode == VAL38)
	drawingmode = VAL39;

      if (drawingmode == VAL39)
	{
	  setvisi (i, j);
	  drplt ();
	  return;
	}

      if (drawingmode == VAL42)
	{
	  setvisi (i, j);
	  dx = x - lx;
	  dy = y - ly;

	  if (VAL1 == VAL14)
	    {
	      dr = ActiveDrawing;
	      dr->x1 += dx;
	      dr->y1 += dy;
	      dr->x2 += dx;
	      dr->y2 += dy;
	    }
	  else if (VAL1 == VAL5)
	    {
	      dr = ActiveDrawing;
	      dr->x2 += dx;
	      dr->y2 += dy;
	    }
	  else if (VAL1 == VAL15)
	    {
	      dr = ActiveDrawing;
	      dr->x1 += dx;
	      dr->y1 += dy;
	    }
	  lx = x;
	  ly = y;
	  drplt ();
	  cpypix ();
	}
      return;
    }

  switch (FLAG2)
    {
    case VAL30:
      {
	setvisi (i, j);
	drplt ();
	break;
      }
    case VAL10:
      {
	setvisi (i, j);
	dx = x - lx;
	dy = y - ly;

	if (VAL1 == VAL2)
	  {
	    tomv (draw);
	    VAL1 = VAL14;
	  }
	if (VAL1 == VAL14)
	  {
	    grx += dx;
	    gry += dy;
	    lx = x;
	    ly = y;

	    cpypix ();
	    break;
	  }
	if (VAL1 == VAL4)
	  {
	    grx += dx;
	    grw -= dx;
	    grh += dy;
	  }
	if (VAL1 == VAL5)
	  {
	    grw += dx;
	    grh += dy;
	  }
	if (VAL1 == VAL15)
	  {
	    grx += dx;
	    gry += dy;
	    grw -= dx;
	    grh -= dy;
	  }
	if (VAL1 == VAL7)
	  {
	    gry += dy;
	    grw += dx;
	    grh -= dy;
	  }
	if (VAL1 == VAL16)
	  {
	    grx += dx;
	    grw -= dx;
	  }
	if (VAL1 == VAL17)
	  {
	    grw += dx;
	  }
	if (VAL1 == VAL18)
	  {
	    gry += dy;
	    grh -= dy;
	  }
	if (VAL1 == VAL6)
	  {
	    grh += dy;
	  }
	if (grw < 50)
	  grw = 50;
	if (grh < 40)
	  grh = 40;
	lx = x;
	ly = y;
	cpypix ();

	break;
      }
    case VAL11X:
      {
	if ((ly - y) * (ly - y) < 9)
	  break;
	dy = y - ly;
	ly = y;

	if (dy < 0 && AW->lh[li] + dy - AW->lh[li - 1] < 10)
	  break;
	for (i = li; i <= AW->nlin; i++)
	  AW->lh[i] += dy;
	bdrepnt (VAL11X);
	break;
      }

    case VAL12:
      {
	if ((lx - x) * (lx - x) < 9)
	  break;
	dx = x - lx;
	lx = x;

	if (dx < 0 && AW->cw[cj] + dx - AW->cw[cj - 1] < 10)
	  break;
	for (j = cj; j <= AW->ncol; j++)
	  AW->cw[j] += dx;
	bdrepnt (VAL12);
	break;
      }
    case VAL19:
      {
	if (!(lsti - i) && !(lstj - j))
	  break;
	tomv (draw);
	mvsel (dwni, dwnj, i, j, 0);
	setvisi (i, j);
	break;
      }
    case VAL13:
      {
	if (FLAG1 == VAL20)
	  selection (dwni, dwnj);
	else
	  {
	    xytoij (x, y, &i, &j);
	    if (i != 0 && j != 0)
	      selection (i, j);
	    setvisi (i, j);
	  }
      }
    case VAL22:
      {

	flag2 = 0;
	flag3 = 0;
	isselectingbtn = 0;
	if (FLAG1 == VAL20)
	  selection (dwni, dwnj);
	else
	  {
	    xytoij (x, y, &i, &j);
	    if (i != 0 && j != 0)
	      selection (i, j);
	    setvisi (i, j);
	  }
      }
    }

  FLAG1 = VAL37;
  lsti = i;
  lstj = j;

}

void
cbdb1down (Widget w, XEvent * event, String * params, int *num_params)
{
  int i, j, k;
  int x, y;
  Graph *gr;
  Button *btn;

  x = event->xbutton.x * 100 / zm;
  y = event->xbutton.y * 100 / zm;

  dwnx = x;
  dwny = y;
  absdwnx = dwnx + AW->cw[AW->cc];
  absdwny = dwny + AW->lh[AW->ll];

  xytoij (dwnx, dwny, &i, &j);

  dwni = i;
  dwnj = j;
  lsti = i;
  lstj = j;

  FLAG1 = VAL20;

  if (drawingmode)
    {
      if (flag4)
	a_update ();
      if (drawingmode == VAL41 && ActiveDrawing != NULL)
	{
	  drawingmode = VAL42;
	  lx = x;
	  ly = y;
	  if (abs (ActiveDrawing->x1 - absdwnx) <= 5 && abs (ActiveDrawing->y1 - absdwny) <= 5)
	    {
	      totopleft (draw);
	      VAL1 = VAL15;
	    }
	  else if (abs (ActiveDrawing->x2 - absdwnx) <= 5 && abs (ActiveDrawing->y2 - absdwny) <= 5)
	    {
	      tobotrig (draw);
	      VAL1 = VAL5;
	    }
	  else
	    {
	      tomv (draw);
	      VAL1 = VAL14;
	    }
	}
      return;
    }

  if (FLAG2 == VAL30)
    return;

  if (FLAG2 == VAL13)
    {
      return;
    }
  if (VAL1 == VAL3)
    {
      FLAG2 = VAL19;
      flag2 = 0;
      flag3 = 0;
      isselectingbtn = 0;
      return;
    }
  if (VAL1 == VAL21)
    {
      FLAG2 = VAL22;
      return;
    }
  if (VAL1 == VAL4 ||
      VAL1 == VAL5 ||
      VAL1 == VAL7 ||
      VAL1 == VAL18 ||
      VAL1 == VAL17 ||
      VAL1 == VAL6 ||
      VAL1 == VAL16 ||
      VAL1 == VAL15)
    {
      lx = dwnx;
      ly = dwny;
      if (flag2)
	FLAG2 = VAL10;
      if (flag3)
	FLAG2 = VAL9ING;
      return;
    }
  if (w == colind)
    {
      FLAG2 = VAL12;
      xytocloij (dwnx, dwny, &i, &j);
      cj = j;
      lx = dwnx;
      flag2 = 0;
      flag3 = 0;
      isselectingbtn = 0;
      return;
    }
  if (w == linind)
    {
      FLAG2 = VAL11X;
      xytocloij (dwnx, dwny, &i, &j);
      li = i;
      ly = dwny;
      flag2 = 0;
      flag3 = 0;
      isselectingbtn = 0;
      return;
    }
  if (w == corner)
    {
      FLAG2 = VAL43;
      flag2 = 0;
      flag3 = 0;
      isselectingbtn = 0;
      return;
    }
  if (flag4 && flag5)
    {

      FLAG2 = VAL13;
      rstsel (i, j, 0);
      flag2 = 0;
      flag3 = 0;
      isselectingbtn = 0;
      return;
    }
  if (flag4 && !flag5)
    {
      a_update ();
    }
  for (k = 0; k < getngr (); k++)
    {
      gr = (Graph *) getgr (k);
      grx = gr->x;
      gry = gr->y;
      grw = gr->w;
      grh = gr->h;
      if (dwnx > grx - AW->cw[AW->cc] && dwny > gry - AW->lh[AW->ll] &&
	  dwnx < (grx - AW->cw[AW->cc]) + (grw) && dwny < (gry - AW->lh[AW->ll]) + (grh))
	{
	  lx = dwnx;
	  ly = dwny;
	  rstsel (i, j, 1);
	  if (flag3)
	    {
	      flag3 = 0;
	      xrepnt ();
	    };
	  if (flag2 != k + 1)
	    {
	      flag2 = k + 1;
	      drawselect ();
	    }
	  setactivegra (k);
	  FLAG2 = VAL10;
	  return;
	}
    }
  for (k = 0; k < getnumbtn (); k++)
    {
      btn = (Button *) getbtn (k);

      if (dwnx > btn->x1 - AW->cw[AW->cc] && dwny > btn->y1 - AW->lh[AW->ll] &&
	  dwnx < btn->x2 - AW->cw[AW->cc] && dwny < btn->y2 - AW->lh[AW->ll]
	)
	{

	  lx = dwnx;
	  ly = dwny;
	  isselectingbtn = k + 1;
	  setactivebtn (k);
	  FLAG2 = CB_BUTTON;
	  redrawbtdown (btn);
	  cpypix ();
	  return;
	}
    }

  flag3 = 0;
  if (flag2)
    {
      flag2 = 0;
      xrepnt ();
    };

  rstsel (0, 0, 1);
  FLAG2 = VAL22;
}

void
mpst (Widget w, XEvent * event, String * params, int *num_params)
{
  if (VAL24 == VAL22)
    paste ();
  if (VAL24 == VAL10)
    {
      pastegra ();
      xrepnt ();
    }
  if (VAL24 == VAL9ING)
    {
      pastedra ();
      xrepnt ();
    }
}

void
mbrsh (Widget w, XEvent * event, String * params, int *num_params)
{
  setbrsh (applicationcell (dwni, dwnj, 1));
  tospray (draw);
  VAL1 = VAL35;

}

void
m_sum (Widget w, XEvent * event, String * params, int *num_params)
{
  char buf[128];
  char buf2[8];
  int col, startr, endr;
  char *txt;

  if (!flag4)
    return;
  if (ActiveCell->r < 2)
    return;

  col = ActiveCell->c;
  endr = ActiveCell->r - 1;
  startr = endr;

  txt = (char *) get_text (startr, col);
  if (txt == NULL)
    return;

  while (startr > 1 && txt != NULL)
    {
      startr--;
      txt = (char *) get_text (startr, col);

    }
  startr++;

  sprintf (buf, "+sum (");
  n2a (buf2, startr, col);
  strcat (buf, buf2);
  strcat (buf, ":");
  n2a (buf2, endr, col);
  strcat (buf, buf2);
  strcat (buf, ")");

  insstr (Letxt, buf);

}

void
m_sorta (Widget w, XEvent * event, String * params, int *num_params)
{
  makesorta ();
}

void
m_sortd (Widget w, XEvent * event, String * params, int *num_params)
{
  makesortd ();
}

void
mcpy (Widget w, XEvent * event, String * params, int *num_params)
{
  if (flag2 == 1)
    {
      cpygr (getactivegra ());
      VAL24 = VAL10;
    }
  else if (drawingmode)
    {
      cpydr (getactivedra ());
      VAL24 = VAL9ING;
    }
  else
    {
      copy ();
      VAL24 = VAL22;
    }

}

void
mcut ()
{
  if (flag2 == 1)
    {
      cutgra (getactivegra ());
      flag2 = 0;
      xrepnt ();
      VAL24 = VAL10;
    }
  else if (drawingmode)
    {
      cutdra (getactivedra ());
      flag3 = 0;
      xrepnt ();
      VAL24 = VAL9ING;
    }
  else
    {
      cut ();
      VAL24 = VAL22;
    }
}

void
cb_DocDelete ()
{
  mcut ();
}

void
m_incr ()
{
  incr ();
}

void
m_color ()
{
  color ();
}

void
m_fit ()
{
  fit ();
  xrepnt ();
}

void
m_ofac (Widget w, XtPointer client_data, XtPointer call_data)
{
}

void
m_ofile (Widget w, XtPointer client_data, XtPointer call_data)
{
  char *buf;
  openfl (buf);
}

void
m_nfile (Widget w, XtPointer client_data, XtPointer call_data)
{
  newdoc (NULL);
}

void
m_as (Widget w, XtPointer client_data, XtPointer call_data)
{
  workbook_as (ActiveWorkbook, NULL);
}

void
m_ds (Widget w, XtPointer client_data, XtPointer call_data)
{

}

void
m_insertline (Widget w, XtPointer client_data, XtPointer call_data)
{
  insertline ();
}

void
m_insertcolumn (Widget w, XtPointer client_data, XtPointer call_data)
{
  insertcolumn ();
}

void
m_changewin (Widget w, XtPointer client_data, XtPointer call_data)
{
  rstsel (0, 0, 0);
  Actworkbook2 (XtName (w));

}

void
m_sfile (Widget w, XtPointer client_data, XtPointer call_data)
{
  savefl ();
}

void
m_sasfile (Widget w, XtPointer client_data, XtPointer call_data)
{
  char *buf;
  saveasfile (buf);
}

void
m_printfl (Widget w, XtPointer client_data, XtPointer call_data)
{
  char *buf;
  printfl (buf);
}

void
m_update ()
{
}

void
mcpyd ()
{

  cpyd ();
}
void
mcpyr ()
{

  cpyr ();
}

void
m_creaplt ()
{
  FLAG4 = VAL30;
  FLAG2 = VAL30;
  drawingmode = 0;
  flag2 = 0;
  tocross (draw);
  return;
}

void
m_plotline ()
{

  FLAG4 = VAL31;
  tocross (draw);
  drawingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotrect ()
{
  FLAG4 = VAL32;
  tocross (draw);
  drawingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotarc ()
{
  FLAG4 = VAL33;
  tocross (draw);
  drawingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotcircle ()
{
  FLAG4 = VAL34;
  tocross (draw);
  drawingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}
void
m_plotbutton ()
{
  FLAG4 = CB_BUTTON;
  tocross (draw);
  drawingmode = VAL38;
  flag2 = 0;
  rstsel (0, 0, 0);
  return;
}

void
m_editdraw ()
{
  drawingmode = VAL41;
  VAL1 = VAL23;
  TurnOnPencil (draw);
  flag2 = 0;
  rstsel (0, 0, 0);
}

void
m_exitdraw ()
{
  VAL1 = VAL2;
  toffcur (draw);
  drawingmode = 0;
}

int
drplt ()
{
  Graph *gr;
  Drawing *dr;
  Button *btn;
  int centerx, centery, width, height, a1, a2;
  int pi = 90 * 64;

  if (FLAG1 == VAL36 || drawingmode == VAL40)
    {
      plotx = absdwnx;
      ploty = absdwny;
      ploth = aupy - absdwny;
      if (ploth < 0)
	{
	  ploth = -ploth;
	  ploty = aupy;
	}
      plotw = aupx - absdwnx;
      if (plotw < 0)
	{
	  plotw = -plotw;
	  plotx = aupx;
	}
      switch (FLAG4)
	{
	case VAL30:
	  {
	    gr = (Graph *) newgra ();
	    if (plotw < 50)
	      plotw = 50;
	    if (ploth < 40)
	      ploth = 40;
	    if (plotx < 0)
	      plotx = 0;
	    if (ploty < 0)
	      ploty = 0;

	    gr->x = plotx;
	    gr->y = ploty;
	    gr->w = plotw;
	    gr->h = ploth;
	    gr->pixmap = createpixmap (draw, plotw, ploth);
	    fillrectangle (dpy, gr->pixmap, 0, 0, 0, plotw, ploth, 0, 0, 0);
	    plot ();
	    cpypix ();
	    break;
	  }
	case VAL31:
	  {
	    dr = (Drawing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL31;
	    drawline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], upx, upy, 0, 0);
	    break;
	  }
	case VAL32:
	  {
	    dr = (Drawing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL32;
	    drawline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], upx, absdwny - AW->lh[AW->ll], 0, 0);
	    drawline (dpy, pixmap, 1, upx, absdwny, upx, upy, 0, 0);
	    drawline (dpy, pixmap, 1, upx, upy, absdwnx - AW->cw[AW->cc], upy, 0, 0);
	    drawline (dpy, pixmap, 1, absdwnx - AW->cw[AW->cc], upy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], 0, 0);
	    break;
	  }
	case CB_BUTTON:
	  {
	    char *label;
	    btn = (Button *) newbtn ();
	    label = inputbox ("Button label:", "Button Label", "button");
	    button_setlabel (btn, label);
	    label = inputbox ("Button macro:", "Button Macro", "macro1");
	    button_setmacro (btn, label);

	    btn->x1 = absdwnx;
	    btn->x2 = aupx;
	    btn->y1 = absdwny;
	    btn->y2 = aupy;
	    fillrectangle (dpy, pixmap, 3, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll],
			   upx - (absdwnx - AW->cw[AW->cc]), upy - (absdwny - AW->lh[AW->ll]), 0, 0, 0);
	    break;
	  }
	case VAL33:
	  {
	    dr = (Drawing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL33;
	    centerx = absdwnx;
	    centery = absdwny;
	    width = 2 * abs (absdwnx - aupx);
	    height = 2 * abs (absdwny - aupy);

	    if (absdwnx <= aupx && absdwny <= aupy)
	      {
		a1 = 0;
		a2 = pi;
		centery += height / 2;
	      }
	    if (absdwnx >= aupx && absdwny <= aupy)
	      {
		a1 = -pi;
		a2 = pi;
		centerx -= width / 2;
	      }
	    if (absdwnx >= aupx && absdwny >= aupy)
	      {
		a1 = 2 * pi;
		a2 = pi;
		centery -= height / 2;
	      }
	    if (absdwnx <= aupx && absdwny >= aupy)
	      {
		a1 = pi;
		a2 = pi;
		centerx += width / 2;
	      }
	    drawarc
	      (dpy, pixmap, 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, a1, a2, 0, 0);
	    break;
	  }
	case VAL34:
	  {
	    dr = (Drawing *) newdra ();
	    dr->x1 = absdwnx;
	    dr->x2 = aupx;
	    dr->y1 = absdwny;
	    dr->y2 = aupy;
	    dr->type = VAL34;
	    centerx = (absdwnx + aupx) / 2;
	    centery = (absdwny + aupy) / 2;
	    width = abs (absdwnx - aupx);
	    height = abs (absdwny - aupy);
	    drawarc
	      (dpy, pixmap, 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, 0, 360 * 64, 0, 0);
	    break;
	  }
	}
      FLAG4 = -1;
      TurnOffCross (draw);
      return 0;
    }
  else
    {
      clearnflush ();

      if (FLAG4 == VAL30 || FLAG4 == VAL10)
	{
	  drawline (dpy, XtWindow (draw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, absdwny - AW->lh[AW->ll], 0, 0);
	  drawline (dpy, XtWindow (draw), 1, mvx, absdwny, mvx, mvy, 0, 0);
	  drawline (dpy, XtWindow (draw), 1, mvx, mvy, absdwnx - AW->cw[AW->cc], mvy, 0, 0);
	  drawline (dpy, XtWindow (draw), 1, absdwnx - AW->cw[AW->cc], mvy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], 0, 0);
	}

    }

  if (drawingmode == VAL39 || drawingmode == VAL42)
    {
      clearnflush ();

      switch (FLAG4)
	{
	case VAL31:
	  {
	    drawline (dpy, XtWindow (draw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, mvy, 0, 0);
	    break;
	  }
	case VAL32:
	  {
	    drawline (dpy, XtWindow (draw), 1, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], mvx, absdwny - AW->lh[AW->ll], 0, 0);
	    drawline (dpy, XtWindow (draw), 1, mvx, absdwny - AW->lh[AW->ll], mvx, mvy, 0, 0);
	    drawline (dpy, XtWindow (draw), 1, mvx, mvy, absdwnx - AW->cw[AW->cc], mvy, 0, 0);
	    drawline (dpy, XtWindow (draw), 1, absdwnx - AW->cw[AW->cc], mvy, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll], 0, 0);
	    break;
	  }
	case CB_BUTTON:
	  {
	    fillrectangle (dpy, XtWindow (draw), 3, absdwnx - AW->cw[AW->cc], absdwny - AW->lh[AW->ll],
			   mvx - (absdwnx - AW->cw[AW->cc]), mvy - (absdwny - AW->lh[AW->ll]), 0, 0, 0);
	    break;
	  }
	case VAL33:
	  {
	    aupx = mvx + AW->cw[AW->cc];
	    aupy = mvy + AW->lh[AW->ll];
	    centerx = absdwnx;
	    centery = absdwny;
	    width = 2 * abs (absdwnx - aupx);
	    height = 2 * abs (absdwny - aupy);
	    if (absdwnx <= aupx && absdwny <= aupy)
	      {
		a1 = 0;
		a2 = pi;
		centery += height / 2;
	      }
	    if (absdwnx >= aupx && absdwny <= aupy)
	      {
		a1 = -pi;
		a2 = pi;
		centerx -= width / 2;
	      }
	    if (absdwnx >= aupx && absdwny >= aupy)
	      {
		a1 = 2 * pi;
		a2 = pi;
		centery -= height / 2;
	      }
	    if (absdwnx <= aupx && absdwny >= aupy)
	      {
		a1 = pi;
		a2 = pi;
		centerx += width / 2;
	      }
	    drawarc
	      (dpy, XtWindow (draw), 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height / 2) - AW->lh[AW->ll], width, height, a1, a2, 0, 0);

	    break;
	  }
	case VAL34:
	  {
	    aupx = mvx + AW->cw[AW->cc];
	    aupy = mvy + AW->lh[AW->ll];
	    centerx = (absdwnx + aupx) / 2;
	    centery = (absdwny + aupy) / 2;
	    width = abs (absdwnx - aupx);
	    height = abs (absdwny - aupy);
	    drawarc
	      (dpy, XtWindow (draw), 1, (centerx - width / 2) - AW->cw[AW->cc], (centery - height /
		     2) - AW->lh[AW->ll], width, height, 0, 360 * 64, 0, 0);
	    break;
	  }
	}
    }
  return 0;
}

int
drawselect ()
{
  int x1, x2, y1, y2;
  int i1, j1, i2, j2;
  Drawing *dr;
  double fact = 100.0 / zm;

  if (drawingmode == VAL41 || drawingmode == VAL42)
    {
      dr = ActiveDrawing;
      if (dr == NULL || !getndr ())
	{
	  return -1;
	}
      xa = dr->x1 - AW->cw[AW->cc];
      ya = dr->y1 - AW->lh[AW->ll];
      xb = dr->x2 - AW->cw[AW->cc];
      yb = dr->y2 - AW->lh[AW->ll];
      fillrectangle (dpy, XtWindow (draw), 1, xa - 4, ya - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xb - 4, yb - 4, 8, 8, 0, 0, 0);
      return 0;
    }

  if (flag2)
    {

      xa = grx - AW->cw[AW->cc] - 4;
      ya = gry - AW->lh[AW->ll] - 4;
      xb = grx - AW->cw[AW->cc] + grw + 4;
      yb = gry - AW->lh[AW->ll] + grh + 4;
      drawline (dpy, XtWindow (draw), 1, xa, ya, xb, ya, 0, 0);
      drawline (dpy, XtWindow (draw), 1, xb, ya, xb, yb, 0, 0);
      drawline (dpy, XtWindow (draw), 1, xb, yb, xa, yb, 0, 0);
      drawline (dpy, XtWindow (draw), 1, xa, yb, xa, ya, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xa - 4, ya - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xa - 4, yb - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xb - 4, ya - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xb - 4, yb - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, (xa + xb) / 2, ya - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, (xa + xb) / 2, yb - 4, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xa - 4, (ya + yb) / 2, 8, 8, 0, 0, 0);
      fillrectangle (dpy, XtWindow (draw), 1, xb - 4, (ya + yb) / 2, 8, 8, 0, 0, 0);

      return 0;
    }

  if (!get_select (&i1, &j1, &i2, &j2))
    return 0;

  if (i2 >= i1 && j2 >= j1)
    {
      i2++;
      j2++;
    }
  if (i2 < i1 && j2 >= j1)
    {
      j2++;
      i1++;
    }
  if (i2 >= i1 && j2 < j1)
    {
      i2++;
      j1++;
    }
  if (i2 < i1 && j2 < j1)
    {
      i1++;
      j1++;
    }
  ijtoxy (i1, j1, &x1, &y1);
  ijtoxy (i2, j2, &x2, &y2);

  if (x1 < 0)
    x1 = 0;
  if (x2 < 0)
    x2 = 0;
  if (y1 < 0)
    y1 = 0;
  if (y2 < 0)
    y2 = 0;
  if (x1 > Width * fact)
    x1 = Width * fact;
  if (x2 > Width * fact)
    x2 = Width * fact;
  if (y1 > Height * fact)
    y1 = Height * fact;
  if (y2 > Height * fact)
    y2 = Height * fact;

  setlineattributes (dpy, 1, 3, LineOnOffDash, CapButt, JoinBevel);
  drawline (dpy, XtWindow (draw), 1, x1, y1, x2, y1, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x2, y1, x2, y2, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x2, y2, x1, y2, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x1, y2, x1, y1, 0, 0);
  setlineattributes (dpy, 1, 1, LineSolid, CapButt, JoinBevel);
  drawline (dpy, XtWindow (draw), 1, x2 - 5, y2 - 5, x2 + 5, y2 - 5, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x2 + 5, y2 - 5, x2 + 5, y2 + 5, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x2 + 5, y2 + 5, x2 - 5, y2 + 5, 0, 0);
  drawline (dpy, XtWindow (draw), 1, x2 - 5, y2 + 5, x2 - 5, y2 - 5, 0, 0);
  selX0 = x1;
  selY0 = y1;
  return 0;
}

int
cbsetup (Widget _toplevel, Widget drawzone, Dimension width, Dimension height, Widget _colind,
	 Widget _linind, Widget _text, Widget _info, Widget _corner)
{
  int D;

  Height = height;
  Width = width;

  win = XtWindow (drawzone);
  dpy = XtDisplay (drawzone);
  screen = DefaultScreen (dpy);
  draw = drawzone;

  setXparam (dpy, win, _toplevel);

  Letxt = _text;
  VAL44 = Letxt;
  linind = _linind;
  colind = _colind;
  toplevel = _toplevel;
  info = _info;
  corner = _corner;

  D = DefaultDepth (dpy, DefaultScreen (dpy));
  pixmap = createpixmap (draw, width, height);
  setbackpix (draw, pixmap);
  setzm (100);
  linpixmap = createpixmap (linind, 30, height);
  colpixmap = createpixmap (colind, width, 20);
  cornerpixmap = createpixmap (corner, 30, 20);
  setbackpix (linind, linpixmap);
  setbackpix (colind, colpixmap);
  setbackpix (corner, cornerpixmap);

  init_application ();
  xrepnt ();
  setbackpix (draw, pixmap);
  XtSetKeyboardFocus (toplevel, draw);
  return 0;
}

int
cbrepnt (int l, int c, Dimension width, Dimension height)
{
  double L, C;

  if (c < 1 || c > AW->ncol)
    c = AW->cc;;
  if (l < 1 || l > AW->nlin)
    l = AW->ll;
  if (AW->cc == c && AW->ll == l)
    return 0;
  lx -= AW->cw[c] - AW->cw[AW->cc];
  ly -= AW->lh[l] - AW->lh[AW->ll];

  AW->cc = c;
  AW->ll = l;

  C = c;
  L = l;
  setscrollv (L);
  setscrollh (C);

  xrepnt ();
  return 0;
}

String
getstring (Widget w)
{
  char *str;
  Arg arglist[1];
  XtSetArg (arglist[0], XtNstring, &str);
  XtGetValues (w, arglist, 1);

  return (str);
}

int
setstring (Widget w, char *str)
{
  Arg arglist[1];

  XtSetArg (arglist[0], XtNstring, str);

  XtSetValues (w, arglist, 1);
  return 0;
}

int
inform (char *str)
{
  Arg arglist[1];

  XtSetArg (arglist[0], XtNstring, str);
  XtSetValues (info, arglist, 1);
  return 0;
}

int
insstr (Widget w, char *str)
{
  XawTextBlock text;
  long p = XawTextGetInsertionPoint (w);
  text.firstPos = 0;
  text.length = strlen (str);
  text.ptr = str;
  XawTextReplace (w, p, p, &text);
  XawTextSetInsertionPoint (w, p + text.length);
  cb_TextChange ();
  return 0;
}

int
mvinspt (Widget w, int delta)
{
  XawTextPosition p = XawTextGetInsertionPoint (w);
  XawTextSetInsertionPoint (w, p + delta);
  return 0;
}

int
xytoij (int x, int y, int *i, int *j)
{
  int jj = 0;
  int x1, x2, y1, y2;
  x += AW->cw[AW->cc];
  y += AW->lh[AW->ll];
  getvisi (&x1, &x2, &y1, &y2);
  while (x > AW->cw[jj])
    {
      jj++;
    }
  *j = jj - 1;
  jj = 0;
  while (y > AW->lh[jj])
    {
      jj++;
    }
  *i = jj - 1;

  if (*i < 1)
    *i = 1;
  if (*j < 1)
    *j = 1;
  if (*i > AW->nlin - 1)
    *i = AW->nlin - 1;
  if (*j > AW->ncol - 1)
    *j = AW->ncol - 1;

  if (x < x1 + AW->cw[1])
    *j = 1;
  if (y < y1 + AW->lh[1])
    *i = 1;

  return 1;
}

int
ijtoxy (int i, int j, int *x, int *y)
{
  *x = AW->cw[j];
  *y = AW->lh[i];

  *x -= AW->cw[AW->cc];
  *y -= AW->lh[AW->ll];

  return 1;
}

int
absijtoxy (int i, int j, int *x, int *y)
{
  *x = AW->cw[j];
  *y = AW->lh[i];

  return 1;
}

int
xytocloij (int x, int y, int *i, int *j)
{
  int jj = 0;
  x += AW->cw[AW->cc];
  y += AW->lh[AW->ll];
  while (x > AW->cw[jj])
    {
      jj++;
    }
  *j = jj - 1;
  if (AW->cw[jj] - x < x - AW->cw[jj - 1])
    *j = jj;
  jj = 0;
  while (y > AW->lh[jj])
    {
      jj++;
    }
  *i = jj - 1;
  if (AW->lh[jj] - y < y - AW->lh[jj - 1])
    *i = jj;

  if (*i < 1)
    *i = 1;
  if (*j < 1)
    *j = 1;
  if (*i > AW->nlin - 1)
    *i = AW->nlin - 1;
  if (*j > AW->ncol - 1)
    *j = AW->ncol - 1;

  return 1;
}

int
xfit (int ii, int jj, char *name)
{
  int cheight, cwidth;
  int di, dj, i, j;

  if (AW->lh[ii + 1] - AW->lh[ii] < cheight)
    {
      di = cheight - (AW->lh[ii + 1] - AW->lh[ii]);
      for (i = ii + 1; i <= AW->nlin; i++)
	AW->lh[i] += di;
    }
  if (AW->cw[jj + 1] - AW->cw[jj] < cwidth)
    {
      dj = cwidth - (AW->cw[jj + 1] - AW->cw[jj]);
      for (j = jj + 1; j < AW->ncol; j++)
	AW->cw[j] += dj;
    }
  return 0;
}

int
xfitcolumn (int ii, int jj)
{
  int cwidth;
  int dj, j;
  int font, fontw, fonts;
  char *name;
  Cell *cell = (Cell *) applicationcell (ii, jj, -1);
  if (cell == NULL)
    return -1;
  name = cell_gtext (cell);
  if (name == NULL)
    return 0;
  if (strlen (name) < 1)
    return 0;

  font = cell_gfont (cell);
  fontw = cell_gfontw (cell);
  fonts = cell_gfonts (cell);

  cwidth = gettextw (name, strlen (name), font, fontw, fonts) + 2;

  if (AW->cw[jj + 1] - AW->cw[jj] < cwidth)
    {
      dj = cwidth - (AW->cw[jj + 1] - AW->cw[jj]);
      for (j = jj + 1; j < AW->ncol; j++)
	AW->cw[j] += dj;
    }
  return 0;
}

int
xfitline (int ii, int jj)
{
  int cheight;
  int di, i;
  int font, fontw, fonts;
  char *name;
  Cell *cell = (Cell *) applicationcell (ii, jj, -1);
  if (cell == NULL)
    return -1;

  name = cell_gtext (cell);
  if (name == NULL)
    return 0;
  if (strlen (name) < 1)
    return 0;

  font = cell_gfont (cell);
  fontw = cell_gfontw (cell);
  fonts = cell_gfonts (cell);

  cheight = gettexth (name, strlen (name), font, fontw, fonts) + 2;

  if (AW->lh[ii + 1] - AW->lh[ii] < cheight)
    {
      di = cheight - (AW->lh[ii + 1] - AW->lh[ii]);
      for (i = ii + 1; i <= AW->nlin; i++)
	AW->lh[i] += di;
    }
  return 0;
}

Widget
getdrwzone ()
{
  return draw;
}

int
getvisi (int *x1, int *x2, int *y1, int *y2)
{
  *x1 = AW->cw[AW->cc];
  *y1 = AW->lh[AW->ll];
  *x2 = *x1 + Width * 100 / zm;
  *y2 = *y1 + Height * 100 / zm;
  return 0;
}

int
getvisi_cells (int *i1, int *j1, int *i2, int *j2)
{
  *i1 = AW->ll;
  *j1 = AW->cc;
  *i2 = *i1;
  *j2 = *j1;

  while (AW->lh[*i2] < AW->lh[AW->ll] + Height * 100 / zm && *i2 < AW->nlin)
    {
      (*i2)++;
    }

  while (AW->cw[*j2] < AW->cw[AW->cc] + Width * 100 / zm && *j2 < AW->ncol)
    {
      (*j2)++;
    }
  return 0;
}

int
setvisi (int i, int j)
{
  int c, l;
  double fact = 100.0 / zm;
  c = AW->cc;
  l = AW->ll;

  if (i > l && j > c && (AW->cw[c] + Width * fact) > (AW->cw[j + 1])
      && (AW->lh[l] + Height * fact) > (AW->lh[i + 1]))
    return 0;

  if (c >= j)
    c = j - 1;
  else
    while ((AW->cw[c] + Width * fact) < (AW->cw[j + 1]) && c < AW->ncol)
      c++;

  if (l >= i)
    l = i - 1;
  else
    while ((AW->lh[l] + Height * fact) < (AW->lh[i + 1]) && l < AW->nlin)
      l++;

  if (l < 0)
    l = 0;
  if (c < 0)
    c = 0;

  cbrepnt (l, c, Width, Height);
  return 0;
}

int
coldrag (double c)
{
  int C;
  C = c;

  cbrepnt (-1, C, Width, Height);
  return 0;
}

int
lindrag (double l)
{
  int L;
  L = l;

  cbrepnt (L, -1, Width, Height);
  return 0;
}

void
cb_ZoomChange (Widget w, XtPointer cd, XEvent * event, Boolean * ctd)
{

}

int
zmin ()
{
  zm += 10;
  setzm (zm);
  xrepnt ();
  return 0;
}

int
zmout ()
{
  zm -= 10;
  setzm (zm);
  xrepnt ();
  return 0;
}

int
cb_setzm (int z)
{
  Graph *gr;
  int i;

  if (zm == z)
    return 0;
  setzm (z);
  ActiveWorksheet->zm = z;
  zm = z;

  for (i = 0; i < getngr (); i++)
    {
      gr = (Graph *) getgr (i);
      gr->zm = z;
      resizegra (i);
    }
  redrawgra ();
  xrepnt ();
  return 0;
}

int
resizegra ()
{
  Graph *gr;
  gr = (Graph *) getlastgra ();
  freepixmap (draw, gr->pixmap);
  gr->pixmap = createpixmap (draw,
			     gr->w * gr->zm / 100, gr->h * gr->zm / 100);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0,
		 gr->w, gr->h, 0, 0, 0);
  return 0;
}

int
redrawbt (Button * btn)
{
  int x1, x2, y1, y2;

  x1 = btn->x1 - AW->cw[AW->cc];
  y1 = btn->y1 - AW->lh[AW->ll];
  x2 = btn->x2 - AW->cw[AW->cc];
  y2 = btn->y2 - AW->lh[AW->ll];
  drawbuttonup (dpy, pixmap, x1, y1, x2, y2, button_glabel (btn), AW->cw[AW->cc], AW->lh[AW->ll]);
  return 0;
}

int
redrawbtdown (Button * btn)
{
  int x1, x2, y1, y2;
  char *label;

  x1 = btn->x1 - AW->cw[AW->cc];
  y1 = btn->y1 - AW->lh[AW->ll];
  x2 = btn->x2 - AW->cw[AW->cc];
  y2 = btn->y2 - AW->lh[AW->ll];

  drawline (dpy, pixmap, 2, x1, y1, x2 - 1, y1, AW->cw[AW->cc], AW->lh[AW->ll]);
  drawline (dpy, pixmap, 2, x1, y1, x1, y2, AW->cw[AW->cc], AW->lh[AW->ll]);

  drawline (dpy, pixmap, 1, x1 + 1, y1 + 1, x2 - 1, y1 + 1, AW->cw[AW->cc], AW->lh[AW->ll]);
  drawline (dpy, pixmap, 1, x1 + 1, y1 + 2, x1 + 1, y2 - 1, AW->cw[AW->cc], AW->lh[AW->ll]);

  drawline (dpy, pixmap, 1, x2, y1, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
  drawline (dpy, pixmap, 1, x1, y2, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
  drawline (dpy, pixmap, 0, x2 - 1, y1, x2 - 1, y2 - 1, AW->cw[AW->cc], AW->lh[AW->ll]);
  drawline (dpy, pixmap, 0, x1 + 1, y2 - 1, x2 - 1, y2 - 1, AW->cw[AW->cc], AW->lh[AW->ll]);
  fillrectangle (dpy, pixmap, 2, x1 + 2, y1 + 2, x2 - x1 - 3, y2 - y1 - 3, AW->cw[AW->cc], AW->lh[AW->ll], 1);
  label = button_glabel (btn);
  drawstring (dpy, pixmap, 1, x1 + 10, (y1 + y2) / 2, label, strlen (label), AW->cw[AW->cc], AW->lh[AW->ll]);
  return 0;
}

int
redrawdr (Drawing * dr)
{
  int centerx, centery, width, height, a1, a2;
  int pi = 90 * 64;
  int x1, x2, y1, y2;

  x1 = dr->x1 - AW->cw[AW->cc];
  y1 = dr->y1 - AW->lh[AW->ll];
  x2 = dr->x2 - AW->cw[AW->cc];
  y2 = dr->y2 - AW->lh[AW->ll];

  switch (dr->type)
    {

    case VAL31:
      {

	drawline (dpy, pixmap, 1, x1, y1, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case VAL32:
      {
	drawline (dpy, pixmap, 1, x1, y1, x2, y1, AW->cw[AW->cc], AW->lh[AW->ll]);
	drawline (dpy, pixmap, 1, x2, y1, x2, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	drawline (dpy, pixmap, 1, x2, y2, x1, y2, AW->cw[AW->cc], AW->lh[AW->ll]);
	drawline (dpy, pixmap, 1, x1, y2, x1, y1, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case CB_BUTTON:
      {
	fillrectangle (dpy, pixmap, 3, x1, y1, x2 - x1, y2 - y1, AW->cw[AW->cc], AW->lh[AW->ll], 0);
	break;
      }
    case VAL33:
      {
	centerx = x1;
	centery = y1;
	width = 2 * abs (x1 - x2);
	height = 2 * abs (y1 - y2);

	if (x1 <= x2 && y1 <= y2)
	  {
	    a1 = 0;
	    a2 = pi;
	    centery += height / 2;
	  }
	if (x1 >= x2 && y1 <= y2)
	  {
	    a1 = -pi;
	    a2 = pi;
	    centerx -= width / 2;
	  }
	if (x1 >= x2 && y1 >= y2)
	  {
	    a1 = 2 * pi;
	    a2 = pi;
	    centery -= height / 2;
	  }
	if (x1 <= x2 && y1 >= y2)
	  {
	    a1 = pi;
	    a2 = pi;
	    centerx += width / 2;
	  }
	drawarc
	  (dpy, pixmap, 1, centerx - width / 2, centery - height / 2, width, height, a1, a2, AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    case VAL34:
      {
	centerx = (x1 + x2) / 2;
	centery = (y1 + y2) / 2;
	width = abs (x1 - x2);
	height = abs (y1 - y2);
	drawarc
	  (dpy, pixmap, 1, centerx - width / 2, centery - height / 2, width, height, 0, 360 * 64,
	   AW->cw[AW->cc], AW->lh[AW->ll]);
	break;
      }
    }
  return 0;
}

void
cb_grap (Widget w, Widget dialog)
{
  VAL44 = w;
  VAL45 = dialog;
  FLAG2 = VAL13;
}

Pixmap
createpixmapforchart (Graph * gr)
{
  gr->pixmap = createpixmap (draw, gr->w, gr->h);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0, gr->w, gr->h, 0, 0, 0);
  return gr->pixmap;

}

Pixmap
getpixmap (Graph * gr, int *x, int *y, int *w, int *h)
{
  *x = gr->x;
  *y = gr->y;

  *w = gr->w;
  *h = gr->h;
  return gr->pixmap;
}

int
bdrepnt (int n)
{
  int i, j;

  setfont2 (0, 1, 0, 3);
  {
    desactivate_zm ();
    fillrectangle (XtDisplay (corner), cornerpixmap, 2, 0, 0, 30, 20, 0, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 3, 0, 0, 0, 20, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 1, 1, 0, 1, 20, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 3, 0, 0, 30, 0, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 1, 1, 1, 30, 1, 0, 0);

    drawline (XtDisplay (corner), cornerpixmap, 0, 2, 2, 29, 2, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 0, 2, 2, 2, 18, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 3, 2, 19, 29, 19, 0, 0);
    drawline (XtDisplay (corner), cornerpixmap, 3, 29, 2, 29, 18, 0, 0);
    reactivate_zm ();
    clearwin (corner);
  }
  if (n == 0 || n == VAL11X)
    {
      desactivate_zm ();
      fillrectangle (XtDisplay (linind), linpixmap, 2, 0, 0, 30, Height, 0, 0, 0);
      drawline (XtDisplay (linind), linpixmap, 3, 0, 0, 0, Height, 0, 0);
      drawline (XtDisplay (linind), linpixmap, 1, 1, 0, 1, Height, 0, 0);

      reactivate_zm ();
      for (i = AW->ll; AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
	xdrawlincell (i, 0, 0);
      clearwin (linind);
    }
  if (n == 0 || n == VAL12)
    {
      desactivate_zm ();
      fillrectangle (XtDisplay (colind), colpixmap, 2, 0, 0, Width, 20, 0, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 3, 0, 0, Width, 0, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 1, 0, 1, Width, 1, 0, 0);

      reactivate_zm ();
      for (j = AW->cc; AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
	xdrawcolcell (0, j, 0);
      clearwin (colind);
    }
  return 0;
}

int
xrepnt ()
{
  int i, j;
  bdrepnt (0);
  paint = 1;

  fillrectangle (dpy, pixmap, 0, 0, 0, Width * 100 / zm, Height * 100 / zm, 0, 0, 0);

  for (i = AW->ll + 1; AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
    drawline (dpy, pixmap, 2, 0, AW->lh[i] - AW->lh[AW->ll], Width * 100 / zm, AW->lh[i] - AW->lh[AW->ll], 0, 0);
  for (j = AW->cc + 1; AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
    drawline (dpy, pixmap, 2, AW->cw[j] - AW->cw[AW->cc], 0, AW->cw[j] - AW->cw[AW->cc], Height * 100 / zm, 0, 0);

  for (i = AW->ll; i <= AW->mrow && AW->lh[i] - AW->lh[AW->ll] < Height * 100 / zm; i++)
    {
      for (j = AW->cc; j <= AW->mcol[i] && AW->cw[j] - AW->cw[AW->cc] < Width * 100 / zm; j++)
	xdrawcell (i, j, 4);
    }

  redrawdra ();
  redrawbtn ();
  cpypix ();
  paint = 0;
  if (flag4 && HighCell == ActiveCell)
    xdrawcell2 (ActiveCell, 3);
  return 0;
}

void
cb_Repaint (Widget w, XtPointer data, XEvent * event)
{
  xrepnt ();
}

void
cb_redrawdra ()
{
  redrawdra ();
}

int
redrawdra ()
{
  Drawing *gr;
  int i;

  int numdra;

  if (ActiveWorksheet == NULL)
    {
      fprintf (stderr, "ActiveWorksheet =NULL\n");
      return -1;
    }

  numdra = ActiveWorksheet->nbdrawing;
  for (i = 0; i < numdra; i++)
    {
      gr = (Drawing *) getdr (i);
      if (gr != NULL)
	redrawdr (gr);
      else
	fprintf (stderr, "dr =NULL\n");

    }
  return 0;
}

void
cb_redrawgra ()
{
  redrawgra ();
}

int
redrawgra ()
{
  Graph *gr;
  int i;
  int numgra;

  if (ActiveWorksheet == NULL)
    {
      fprintf (stderr, "ActiveWorksheet =NULL\n");
      return -1;
    }
  numgra = ActiveWorksheet->nbchart;

  for (i = 0; i < numgra; i++)
    {
      gr = (Graph *) getgr (i);
      if (gr != NULL)
	newplot (i, gr);
      else
	fprintf (stderr, "gr =NULL\n");

    }
  return 0;

}

int
redrawbtn ()
{
  Button *gr;
  int i;
  int numbtn;

  if (ActiveWorksheet == NULL)
    {
      fprintf (stderr, "ActiveWorksheet =NULL\n");
      return -1;
    }
  numbtn = ActiveWorksheet->nbbutton;

  for (i = 0; i < numbtn; i++)
    {

      gr = (Button *) getbtn (i);
      if (gr != NULL)
	redrawbt (gr);
      else
	fprintf (stderr, "btn =NULL\n");

    }
  paint = 0;
  return 0;
}

void
cpypix ()
{
  Graph *gr;
  int i;
  int numgra;
  if (ActiveWorksheet == NULL)
    {
      fprintf (stderr, "ActiveWorksheet =NULL\n");
      return;
    }

  numgra = ActiveWorksheet->nbchart;

  for (i = 0; i < numgra; i++)
    {
      gr = (Graph *) getgr (i);
      if (gr != NULL)
	copyarea (gr->pixmap, pixmap, 1, 0, 0,
		  gr->w * gr->zm / 100, gr->h * gr->zm / 100,
		  (gr->x - AW->cw[AW->cc]) * gr->zm / 100,
		  (gr->y - AW->lh[AW->ll]) * gr->zm / 100);
    }

  clearnflush ();
  drawselect ();
}

int
cb_resize (int width, int height)
{
  freepixmap (draw, pixmap);
  freepixmap (linind, linpixmap);
  freepixmap (colind, colpixmap);

  Height = height - 20;
  Width = width - 30;
  pixmap = createpixmap (draw, width - 30, height - 20);
  setbackpix (draw, pixmap);

  linpixmap = createpixmap (linind, 30, height - 20);
  colpixmap = createpixmap (colind, width - 30, 20);

  setbackpix (linind, linpixmap);
  setbackpix (colind, colpixmap);
  xrepnt ();
  return 0;
};

static int numover = 0;

int
checkwidth (char *name, int width, Cell * cell, int r, int c, int type)
{
  int cwidth;
  int nchar;
  int i, j;
  int color, just, font, fontw, fonts;
  int delta;
  char *formula = NULL;
  Cell *cl;

  if (name == NULL)
    return 0;
  nchar = strlen (name);
  if (nchar < 1)
    return 0;

  color = cell_gfg (cell);
  just = cell_gjust (cell);
  font = cell_gfont (cell);
  fontw = cell_gfontw (cell);
  fonts = cell_gfonts (cell);

  cwidth = gettextw (name, nchar, font, fontw, fonts);
  if (type == 2 || type == 3)
    delta = AW->cw[c + 1 + numover] - AW->cw[c + 1];
  else
    delta = 0;

  if (cwidth > width - 2 + delta)
    {

      i = r;
      j = c;
      cl = (Cell *) applicationcell (i, j + 1, -1);
      if (cl != NULL)
	formula = cl->formula;
      else
	formula = NULL;
      while (((cwidth > width - 2 + delta && formula == NULL) ||
	      (cwidth > width - 2 + delta && (type == 2 || type == 3))
	     ) &&
	     (width < 1000)
	)
	{
	  j++;
	  if (type == 2 || type == 3)
	    numover++;
	  delta = AW->cw[j + 1] - AW->cw[c + 1];
	  cl = (Cell *) applicationcell (i, j + 1, -1);
	  if (cl != NULL)
	    formula = cl->formula;
	  else
	    formula = NULL;
	}
    }

  return width + delta;

}

int
xdrawstring (char *name, int x, int y, int width, int widthmax, int height, int type, Cell * cell)
{
  int textx, texty;

  int cheight, cwidth;
  int nchar;
  int color, just, font, fontw, fonts;

  if (name == NULL)
    return 0;
  nchar = strlen (name);
  if (nchar < 1)
    return 0;

  font = cell_gfont (cell);
  fontw = cell_gfontw (cell);
  fonts = cell_gfonts (cell);

  cheight = gettexth (name, nchar, font, fontw, fonts);
  cwidth = gettextw (name, nchar, font, fontw, fonts);
  if (height < (cheight + 2))
    return width;

  while (cwidth > widthmax - 2 && nchar > 0)
    {
      nchar--;
      cwidth = gettextw (name, nchar, font, fontw, fonts);
    }
  if (nchar < 1)
    return 0;

  color = cell_gfg (cell);
  just = cell_gjust (cell);

  if (type == 3)
    just = 0;

  if (just == 0)
    textx = x + 1;
  if (just == 1)
    textx = x + width / 2 - cwidth / 2;
  if (just == 2)
    textx = x + width - cwidth;
  if (textx < x + 1)
    textx = x + 1;
  texty = y + height / 2 + cheight / 2 + 1;

  setfont2 (color, font, fontw, fonts);
  drawstring (XtDisplay (draw), pixmap, color, textx, texty, name, nchar, AW->cw[AW->cc], AW->lh[AW->ll]);

  return 0;
}

int
xdrawrrect (int x, int y, int width, int height, int type, Cell * cell)
{

  int bg = cell_gbg (cell);
  int fg = cell_gfg (cell);

  if (bg < 0)
    bg = 0;
  if (fg < 0)
    fg = 5;
  if (type == 0)
    {
      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }
  if (type == 4)
    {

      fillrectangle (dpy, pixmap, 2, x, y, width, height, AW->cw[AW->cc], AW->lh[AW->ll], 0);
      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 1);
    }
  if (type == 7)
    {
      fillrectangle (dpy, pixmap, 2, x, y, width, height, 0, 0, 0);
      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }

  if (type == 2 || type == 3)
    {

      fillrectangle (dpy, pixmap, 1, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 0);

      fillrectangle (dpy, pixmap, bg, x + 2, y + 2, width - 3, height - 3, AW->cw[AW->cc], AW->lh[AW->ll], 0);
    }

  if (type == 5 && bg != 0 && bg != 45)
    {

      fillrectangle (dpy, pixmap, bg, x + 1, y + 1, width - 1, height - 1, AW->cw[AW->cc], AW->lh[AW->ll], 5);
    }

  if (cell_gtop (cell))
    {
      drawline (dpy, pixmap, fg, x, y, x + width, y, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cell_gbot (cell))
    {
      drawline (dpy, pixmap, fg, x + width, y + height, x, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cell_grig (cell))
    {
      drawline (dpy, pixmap, fg, x + width, y, x + width, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  if (cell_glef (cell))
    {
      drawline (dpy, pixmap, fg, x, y, x, y + height, AW->cw[AW->cc], AW->lh[AW->ll]);
    }
  return 0;
}

int
xdrawlincell (int i, int j, int color)
{
  char label[8];
  int height;
  int top;
  int act = 0;

  if (i <= 0)
    return -1;
 if (i > ActiveWorksheet->nlin)
  return -1;

  height = (AW->lh[i + 1] - AW->lh[i]) * zm / 100 - 1;
  top = (AW->lh[i] - AW->lh[AW->ll]) * zm / 100 + 1;
  sprintf (label, "%d", i);
  desactivate_zm ();

/*haut */ drawline (XtDisplay (linind), linpixmap, 0, 2, top, 28, top, 0, 0);

  if (ActiveCell != NULL)
    if (ActiveCell->r == i)
      act = 1;

  fillrectangle (XtDisplay (linind), linpixmap, 2, 2, top + 1, 27, height - 1, 0, 0, 0);

  if (act)
    {
      drawline (XtDisplay (linind), linpixmap, 1, 2, (top + height), 28, (top + height), 0, 0);
      /*bas-in */ drawline (XtDisplay (linind), linpixmap, 3, 3, (top + height) - 1, 27, (top + height) - 1, 0, 0);
      /*gauch */ drawline (XtDisplay (linind), linpixmap, 0, 2, 1 + top, 2, (top + height) - 1, 0, 0);
      /*droi */ drawline (XtDisplay (linind), linpixmap, 1, 29, top, 29, (top + height), 0, 0);
      /*droi-in */ drawline (XtDisplay (linind), linpixmap, 3, 28, top + 1, 28, (top + height) - 1, 0, 0);
      /*droi-in-top */ drawline (XtDisplay (linind), linpixmap, 2, 28, top, 28, top, 0, 0);
    }
  else
    {
      drawline (XtDisplay (linind), linpixmap, 3, 2, (top + height), 28, (top + height), 0, 0);
      /*gauch */ drawline (XtDisplay (linind), linpixmap, 2, 2, top + 1, 2, (top + height) - 1, 0, 0);
      /*droi */ drawline (XtDisplay (linind), linpixmap, 3, 29, top, 29, (top + height), 0, 0);
    }
  reactivate_zm ();

  setfont2 (0, 1, 0, 3);
  drawstring (XtDisplay (linind), linpixmap, 1, 1 + 3 * 100 / zm, (top + height - 4) * 100 / zm, label, strlen (label), 0, 0);
  return 0;
}

int
xdrawcolcell (int i, int j, int color)
{
  char label[4];
  int width;
  int left;
  int act = 0;
  if (j <= 0)
    return -1;
 if (j > ActiveWorksheet->ncol)
  return -1;

  width = AW->cw[j + 1] - AW->cw[j];
  left = AW->cw[j] - AW->cw[AW->cc];

  if (j <= 26)
    {
      label[0] = 'A' + j - 1;
      label[1] = '\0';
    }
  else
    {
      label[0] = 'A' + (j - 1) / 26 - 1;
      label[1] = 'A' + j - 26 * ((j - 1) / 26) - 1;
      label[2] = '\0';
    }

  if (ActiveCell != NULL)
    if (ActiveCell->c == j)
      act = 1;

  desactivate_zm ();
  fillrectangle (XtDisplay (colind), colpixmap, 2, left * zm / 100 + 1, 2, width * zm / 100 - 1, 17, 0, 0, 0);

  if (act)
    {
      drawline (XtDisplay (colind), colpixmap, 0, left * zm / 100 + 1, 2, left * zm / 100 + 1, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 1, (left + width) * zm / 100, 2, (left + width) * zm / 100, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 1, left * zm / 100 + 1, 19, (left + width) * zm / 100 - 1, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 0, left * zm / 100 + 1, 2, (left + width) * zm / 100 - 1, 2, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 3, left * zm / 100 + 1, 18, (left + width) * zm / 100 - 1, 18, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 2, left * zm / 100 + 1, 18, left * zm / 100 + 1, 18, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 3, (left + width) * zm / 100 - 1, 3, (left + width) * zm / 100 - 1, 18, 0, 0);
    }
  else
    {
      drawline (XtDisplay (colind), colpixmap, 0, left * zm / 100 + 1, 2, left * zm / 100 + 1, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 3, (left + width) * zm / 100, 2, (left + width) * zm / 100, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 3, left * zm / 100 + 1, 19, (left + width) * zm / 100 - 1, 19, 0, 0);
      drawline (XtDisplay (colind), colpixmap, 2, left * zm / 100 + 2, 2, (left + width) * zm / 100 - 1, 2, 0, 0);
    }
  reactivate_zm ();

  setfont2 (0, 1, 0, 3);
  drawstring (XtDisplay (colind), colpixmap, 1, left + width / 2 - 5, 15 * 100 / zm, label, strlen (label), 0, 0);
  return 0;
}

int
xdrawcell (int i, int j, int type)
{
  Cell *cell = (Cell *) applicationcell (i, j, -1);
  return xdrawcell2 (cell, type);
}

int
xdrawcell2 (Cell * cell, int type)
{
  int left;
  int top;
  int width;
  int widthmax;
  int height;
  char *buf = NULL;
  int i, j, k;

  if (cell == NULL)
    return -1;

  i = cell->r;
  j = cell->c;

  if (type == 2)
    numover = 0;

  if (type == 6)
    {
      for (k = numover; k > 0; k--)
	{
	  width = AW->cw[j + 1 + k] - AW->cw[j + k];
	  left = AW->cw[j + k] - AW->cw[AW->cc];
	  height = AW->lh[i + 1] - AW->lh[i];
	  top = AW->lh[i] - AW->lh[AW->ll];
	  xdrawrrect (left, top, width, height, 7, ActiveWorksheet->defcell);
	}

      while (numover)
	{
/*	  fprintf (stderr, "numover %d\n", numover);*/
	  xdrawcell (i, j + numover, 7);
	  numover--;
	}
      type = 4;
    }
  if (cell == NULL && (type == 4 || type == 5))
    return 0;

  if (type == 4)
    numover = 0;

  width = AW->cw[j + 1] - AW->cw[j];
  left = AW->cw[j] - AW->cw[AW->cc];
  height = AW->lh[i + 1] - AW->lh[i];
  top = AW->lh[i] - AW->lh[AW->ll];

  if (cell != NULL)
    buf = (char *) cell_gtext (cell);

  if (cell == ActiveCell && HighCell != cell)
    {
      if (HighCell != NULL)
	{
	  xdrawlincell (HighCell->r, 0, 0);
	  xdrawcolcell (0, HighCell->c, 0);
	}
      xdrawlincell (cell->r, 0, 0);
      xdrawcolcell (0, cell->c, 0);
      HighCell = cell;
      clearwin (linind);
      clearwin (colind);
    }

  if (type == 2 && cell != NULL)
    buf = (char *) cell_gformula (cell);

  if (type == 3)
    {
      buf = (char *) getstring (Letxt);
    }

  widthmax = width;
  if (buf != NULL)
    {
      if (type == 3 || type == 2 || (cell_grig (cell) == 0))
	widthmax = checkwidth (buf, width, cell, i, j, type);
    }

  xdrawrrect (left, top, widthmax, height, type, cell);

  if (buf != NULL)
    xdrawstring (buf, left, top, width, widthmax, height, type, cell);

  if (!paint && FLAG1 != VAL37)
    cleararea (dpy, win, left, top, widthmax + 1, height + 1, False);

  return 0;
}

int
createchartpixmap (Graph * gr)
{
  deletechartpixmap (gr);
  gr->pixmap = createpixmap (draw, gr->w, gr->h);
  fillrectangle (dpy, gr->pixmap, 0, 0, 0, gr->w, gr->h, 0, 0, 0);
  return 0;
}

int
deletechartpixmap (Graph * gr)
{
  if (gr)
    if (gr->pixmap)
      {
	freepixmap (draw, gr->pixmap);
	gr->pixmap = 0;
      }
  return 0;
}

void
cb_previous_sheet ()
{
  if (ActiveWorkbook == NULL)
    return;
  if (ActiveWorkbook->first_vis_wks > 0)
    ActiveWorkbook->first_vis_wks--;
  rebuild_thumb ();
}

void
cb_next_sheet ()
{
  if (ActiveWorkbook == NULL)
    return;
  if (ActiveWorkbook->first_vis_wks < ActiveWorkbook->nbworksheet - 1)
    ActiveWorkbook->first_vis_wks++;
  rebuild_thumb ();
}

void
cb_last_sheet ()
{
  if (ActiveWorkbook == NULL)
    return;
  ActiveWorkbook->first_vis_wks = ActiveWorkbook->nbworksheet - 2;
  rebuild_thumb ();
}
void
cb_first_sheet ()
{
  if (ActiveWorkbook == NULL)
    return;
  ActiveWorkbook->first_vis_wks = 0;
  rebuild_thumb ();
}
