/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef CALLBACK_DECL_H
#define CALLBACK_DECL_H
#include "param.h"

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Core.h>
#include <X11/Shell.h>
#include <stdio.h>
#include <X11/Xaw/AsciiText.h>
#include "chart.h"
#include "style.h"
#include "cell.h"
#include "worksheet.h"
#include "workbook.h"
#include "draw.h"

void cb_first_sheet ();
void cb_last_sheet ();
void cb_next_sheet ();
void cb_previous_sheet ();
int deletechartpixmap (Graph * gr);
int createchartpixmap (Graph * gr);
int xdrawrrect (int x, int y, int width, int height, int type, Cell * cell);
int xdrawstring (char *name, int x, int y, int width, int widthmax, int height, int type, Cell * cell);
int checkwidth (char *name, int width, Cell * cell, int r, int c, int type);
int cb_resize (int width, int height);
void cb_redrawgra ();
void cb_redrawdra ();
void cb_Repaint (Widget w, XtPointer data, XEvent * event);
int redrawbtn ();
int redrawdra ();
int xdrawcolcell (int i, int j, int color);
int xdrawlincell (int i, int j, int color);
Pixmap getpixmap (Graph * gr, int *x, int *y, int *w, int *h);
Pixmap createpixmapforchart (Graph * gr);
void cb_grap (Widget w, Widget dialog);
int redrawdr (Drawing * dr);
int redrawgra ();
int cb_setzm (int z);
int zmout ();
int zmin ();
void cb_ZoomChange (Widget w, XtPointer cd, XEvent * event, Boolean * ctd);
int lindrag (double l);
int coldrag (double c);
Widget getdrwzone ();
int xfitline (int ii, int jj);
int xfitcolumn (int ii, int jj);
int xfit (int ii, int jj, char *name);
int absijtoxy (int i, int j, int *x, int *y);
int getvisi (int *x1, int *x2, int *y1, int *y2);
int inform (char *str);
int cbsetup (Widget _toplevel, Widget drawzone, Dimension width, Dimension height, Widget _colind, Widget _linind, Widget _text, Widget _info, Widget _corner);
void m_exitdraw ();
void m_editdraw ();
void m_plotbutton ();
void m_plotcircle ();
void m_plotarc ();
void m_plotrect ();
void m_plotline ();
void m_creaplt ();
void mcpyr ();
void mcpyd ();
void m_update ();

void m_printfl (Widget w, XtPointer client_data, XtPointer call_data);
void m_sasfile (Widget w, XtPointer client_data, XtPointer call_data);
void m_sfile (Widget w, XtPointer client_data, XtPointer call_data);
void m_changewin (Widget w, XtPointer client_data, XtPointer call_data);
void m_insertcolumn (Widget w, XtPointer client_data, XtPointer call_data);
void m_insertline (Widget w, XtPointer client_data, XtPointer call_data);
void m_ds (Widget w, XtPointer client_data, XtPointer call_data);
void m_as (Widget w, XtPointer client_data, XtPointer call_data);
void m_nfile (Widget w, XtPointer client_data, XtPointer call_data);
void m_ofile (Widget w, XtPointer client_data, XtPointer call_data);
void m_ofac (Widget w, XtPointer client_data, XtPointer call_data);
void m_fit ();
void m_color ();
void m_incr ();
void cb_DocDelete ();
void mcut ();
void mcpy (Widget w, XEvent * event, String * params, int *num_params);
void m_sortd (Widget w, XEvent * event, String * params, int *num_params);
void m_sorta (Widget w, XEvent * event, String * params, int *num_params);
void m_sum (Widget w, XEvent * event, String * params, int *num_params);
void mbrsh (Widget w, XEvent * event, String * params, int *num_params);
void mpst (Widget w, XEvent * event, String * params, int *num_params);
int redrawbtdown (Button * btn);
int xytocloij (int x, int y, int *i, int *j);
void cbdb1down (Widget w, XEvent * event, String * params, int *num_params);
int bdrepnt (int n);
void cb_DocBtn1Motion (Widget w, XEvent * event, String * params, int *num_params);
void cb_BtnCancel ();
void cb_BtnOk ();
void cb_TextReturn (Widget w, XEvent * event, String * params, int *num_params);
void cb_TextChange ();
int setvisi (int i, int j);
int resizegra ();
void cpypix ();
int redrawbt (Button * btn);
int drplt ();
void cbpgrig (Widget w, XEvent * event, String * params, int *num_params);
void cbpgleft (Widget w, XEvent * event, String * params, int *num_params);
void cbpgdwn (Widget w, XEvent * event, String * params, int *num_params);
int getvisi_cells (int *i1, int *j1, int *i2, int *j2);
void cbpgup (Widget w, XEvent * event, String * params, int *num_params);
void cb_PageHome (Widget w, XEvent * event, String * params, int *num_params);
void cbdb2up (Widget w, XEvent * event, String * params, int *num_params);
int cbrepnt (int l, int c, Dimension width, Dimension height);
int xytoij (int x, int y, int *i, int *j);
void cbdbt2mv (Widget w, XEvent * event, String * params, int *num_params);
void cbdn2down (Widget w, XEvent * event, String * params, int *num_params);
int ijtoxy (int i, int j, int *x, int *y);
int drawselect ();
void cbdmv (Widget w, XEvent * event, String * params, int *num_params);
void cbbak (Widget w, XEvent * event, String * params, int *num_params);
void cbdel (Widget w, XEvent * event, String * params, int *num_params);
void cbtright (Widget w, XEvent * event, String * params, int *num_params);
void cbtleft (Widget w, XEvent * event, String * params, int *num_params);
void cbtdown (Widget w, XEvent * event, String * params, int *num_params);
void cbdb1up (Widget w, XEvent * event, String * params, int *num_params);
void cbtup (Widget w, XEvent * event, String * params, int *num_params);
int xdrawcell2 (Cell * cell, int type);
int mvinspt (Widget w, int delta);
int insstr (Widget w, char *str);
void echfct (char *buf);
int setstring (Widget w, char *str);
int xdrawcell (int i, int j, int type);
String getstring (Widget w);
void a_update ();
int selectingto0 ();
int xrepnt ();
int repaint_activesheet ();
int cbcgsht (int sheet);
int DoUndoFormula (int r, int c, char *formula);

#endif
