/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef CELL_H
#define CELL_H
#include "style.h"
#include <stdio.h>
#include "object.h"
#include "node.h"

struct _Cell;
struct _Worksheet;

struct _Fam
  {
    struct _Cell **parlst;
    struct _Cell **chilst;
    int npar;
    int nchi;
    int dparlst;
    int dchilst;
  };

typedef struct _Fam Fam;

struct _Cell
  {
    obj val;
    char *formula;
    int flag1;
    int r, c;
    Style *style;
    Fam *familly;
    struct _Worksheet *worksheet;
    int objn;
    nodeType *tree;
  };

typedef struct _Cell Cell;

extern Cell *currentcell;
extern Cell *ActiveCell;

extern Cell *newcell (int r, int c);
extern int freecell (Cell * cell);
extern int clear_cell (Cell * cell);
extern int cell_w (Cell * cell, FILE * fp);

extern int cell_setnumberformat (Cell * cell, char *buf);
extern int cell_setformula (Cell * cell, char *buf);
extern int cell_settext (Cell * cell, char *buf);
extern char *cell_gformula (Cell * cell);
extern char *cell_gnumberformat (Cell * cell);
extern char *cell_gtext (Cell * cell);
extern int cell_istext (Cell * cell);
extern double cell_gvalue (Cell * cell);
extern obj cell_gobj (Cell * cell);
extern double cell_setvalue (Cell * cell, double val);
extern obj cell_setobj (Cell * cell, obj o);
extern obj cell_setresval (Cell * cell, obj o);
extern double cell_setvalue2 (double val);

extern int cell_setbord (Cell * cell, int border, int type);
extern int cell_setfg (Cell * cell, int f);
extern int cell_gfg (Cell * cell);
extern int cell_setbg (Cell * cell, int f);
extern int cell_gbg (Cell * cell);

extern int cell_gtop (Cell * cell);
extern int cell_gbot (Cell * cell);
extern int cell_grig (Cell * cell);
extern int cell_glef (Cell * cell);
extern int cell_settop (Cell * cell, int f);
extern int cell_setbot (Cell * cell, int f);
extern int cell_setrig (Cell * cell, int f);
extern int cell_setlef (Cell * cell, int f);

extern int cell_setformat (Cell * cell, int format, int deci);
extern int cell_gformat (Cell * cell, int *format, int *deci);
extern int cell_setjust (Cell * cell, int j);
extern int cell_gjust (Cell * cell);
extern int cell_setfont (Cell * cell, int f, int w, int s);
extern int cell_gfont (Cell * cell);
extern int cell_gfontw (Cell * cell);
extern int cell_gfonts (Cell * cell);
extern int cell_fname (Cell * cell, char *name);
extern int cell_fontsize (Cell * cell, int v);
extern int cell_fblt (Cell * cell, int v);
extern int cell_fital (Cell * cell, int v);

extern int cell_setbord (Cell * cell, int border, int type);
extern int cell_setborder (Cell * cell, int border);
extern int cell_gborder (Cell * cell);

extern int cell_isnew (Cell * cell);
extern int cell1isfcell2 (Cell * cell1, Cell * cell2);
extern int nupdate2 (Cell * cell, int redraw);

extern int StringInput ();
extern int macroparsing (char *buf);
extern char *textparsing (char *buf);

extern int copymod (int ii, int jj, int i, int j, int incr);
extern int copymod2 (Cell * cell1, Cell * cell2, int curi, int curj, int di, int dj);
extern Cell *cell_cpy (Cell * cell1, Cell * cell2);
extern Cell *cell_stycpy (Cell * cell1, Cell * cell2);

extern int parsecell (Cell * cell);

int cell_chgwksname (Cell * cell, char *oldname, char *newname);
int cell_calculate (Cell * cell);
#endif
