/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef CELL_VB_H
#define CELL_VB_H
#include "cell.h"
#include "object.h"

#include "main.h"

extern obj vb_gcell (int narg, obj * arg);
extern obj vb_grange (int narg, obj * arg);

extern obj vb_g_ActiveCell ();
extern obj vb_g_Selection ();

extern obj vb_cell_setvalue (int narg, obj * arg);
extern obj vb_cell_gvalue (int narg, obj * arg);
extern obj vb_cell_setobj (int narg, obj * arg);
extern obj vb_cell_gobj (int narg, obj * arg);
extern obj vb_cell_setformula (int narg, obj * arg);
extern obj vb_cell_gformula (int narg, obj * arg);
extern obj vb_cell_sethalign (int narg, obj * arg);
extern obj vb_cell_ghalign (int narg, obj * arg);
extern obj vb_cell_setnumform (int narg, obj * arg);
extern obj vb_cell_gnumform (int narg, obj * arg);
extern obj vb_cell_setinterior (int narg, obj * arg);
extern obj vb_cell_ginterior (int narg, obj * arg);
extern obj vb_cell_gborder (int narg, obj * arg);
extern obj vb_cell_gbord (int narg, obj * arg);
extern obj vb_cell_setbord (int narg, obj * arg);
extern obj vb_cell_assign (int narg, obj * arg);
extern obj vb_cell_print (int narg, obj * arg);
extern obj vb_cell_select (int narg, obj * arg);
extern int check_if_id_is_cell (obj o);

extern obj cell_range (obj o1, obj o2);

extern int get_id2row ();
extern int get_id2col ();
extern int setdi (int i);
extern int setdj (int i);
extern int setsi (int i);
extern int setsj (int i);

extern obj modcelltree (nodeType ** p);
extern int execcelltree (Cell * cell);
extern int setcelltree (nodeType * tree);

struct _tmpRange
  {
    struct _Worksheet *wks;
    int r1;
    int c1;
    int r2;
    int c2;
  };

typedef struct _tmpRange tmpRange;

#endif
