/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef COMMANDLINE_H
#define COMMANDLINE_H
#include <stdio.h>
#include "param.h"
#include "cblist.h"
#include "menubar.h"

typedef struct
  {
    int Initialized;
    Widget text, info, cancel, ok;
    Widget btn, menu_popup;

  }
Commandline;

extern Commandline *
  newcommandline (Widget commandline);

extern void echomin ();
extern void echomax ();
extern void echoaverage ();
extern void echoother ();
extern void echocos ();
extern void echoabs ();
extern void echosin ();
extern void echosqrt ();
extern void echotan ();
extern void echomin ();
extern void echomax ();
extern void echosum ();

static struct menuEntry fctMenuEntries[] =
{
  {"AVERAGE", echoaverage},
  {"MIN", echomin},
  {"MAX", echomax},
  {"SUM", echosum},
  {"ABS", echoabs},
  {"COS", echocos},
  {"SIN", echosin},
  {"SQRT", echosqrt},
  {"TAN", echotan},
  {"Other...", echoother},
};

#endif
