/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include <stdio.h>
#include "node.h"
#include "object.h"
#include "y.tab.h"

static int lbl;

int
ex (nodeType * p)
{
  int lbl1, lbl2;

  if (!p)
    return 0;
  switch (p->type)
    {
    case typeCon:
      printf ("\tpush\t%d\n", p->con.value.rec.d);
      break;
    case typeId:
      printf ("\tpush\t%s\n", p->id.id.label);
      break;
    case typeOpr:
      switch (p->opr.oper.rec.i)
	{
	case WHILE:
	  printf ("L%03d:\n", lbl1 = lbl++);
	  ex (p->opr.op[0]);
	  printf ("\tjz\tL%03d\n", lbl2 = lbl++);
	  ex (p->opr.op[1]);
	  printf ("\tjmp\tL%03d\n", lbl1);
	  printf ("L%03d:\n", lbl2);
	  break;
	case IF:
	  ex (p->opr.op[0]);
	  if (p->opr.nops > 2)
	    {

	      printf ("\tjz\tL%03d\n", lbl1 = lbl++);
	      ex (p->opr.op[1]);
	      printf ("\tjmp\tL%03d\n", lbl2 = lbl++);
	      printf ("L%03d:\n", lbl1);
	      ex (p->opr.op[2]);
	      printf ("L%03d:\n", lbl2);
	    }
	  else
	    {

	      printf ("\tjz\tL%03d\n", lbl1 = lbl++);
	      ex (p->opr.op[1]);
	      printf ("L%03d:\n", lbl1);
	    }
	  break;
	case PRINT:
	  ex (p->opr.op[0]);
	  printf ("\tprint\n");
	  break;
	case '=':
	  ex (p->opr.op[1]);
	  printf ("\tpop\t%s\n", p->opr.op[0]->id.id.label);
	  break;
	case UMINUS:
	  ex (p->opr.op[0]);
	  printf ("\tneg\n");
	  break;
	case SUB:
	  ex (p->opr.op[0]);
	  ex (p->opr.op[1]);
	  ex (p->opr.op[2]);
	default:
	  ex (p->opr.op[0]);
	  ex (p->opr.op[1]);
	  switch (p->opr.oper.rec.i)
	    {
	    case '+':
	      printf ("\tadd\n");
	      break;
	    case '-':
	      printf ("\tsub\n");
	      break;
	    case '*':
	      printf ("\tmul\n");
	      break;
	    case '/':
	      printf ("\tdiv\n");
	      break;
	    case '<':
	      printf ("\tcompLT\n");
	      break;
	    case '>':
	      printf ("\tcompGT\n");
	      break;
	    case GE:
	      printf ("\tcompGE\n");
	      break;
	    case LE:
	      printf ("\tcompLE\n");
	      break;
	    case NE:
	      printf ("\tcompNE\n");
	      break;
	    case EQ:
	      printf ("\tcompEQ\n");
	      break;
	    }
	}
    }
}
