/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef MAIN_H
#define MAIN_H

#include "cell.h"

int coltoalpha(char *buf,int i);
int n2a2(char *buf,int j,int i,int dj,int di);
int n2a(char *buf,int j,int i);
int alphatonum(char *buf,int *ii,int *jj);
void updatechart();
int get_select(int *i1,int *j1,int *i2,int *j2);
int is_selecting();
int printplot(int number);
void plot();
int printfl2(char *filename);
int printascii(char *filename);
int printfl(char *filename);
void makeprint(int destination,char *destname,int format);
int myfprintf(FILE *fp,char *word,int l);
int mvsel(int fri,int frj,int toi,int toj,int k);
int selection(int ii,int jj);
int selectall();
int selectcol(int col);
int selectlin(int lin);
int setselection(int i1,int j1,int i2,int j2);
int rstsel(int ii,int jj,int k);
int insertcolumn();
int insertline();
int cpyr();
int cpyd();
int makecolor(int fg,int bg);
int color();
void formatline();
void formatcolumn();
int fit();
int border(int border,int type);
int makefont(int fontnum,int fontweight,int fontsize);
int makejust(int just);
int makeformat(int type,int decimal);
int cut();
int paste();
int copy();
void m_exit();
void exportfile(char *filename,int icomma,int itab,int ispace,int idotcom,int other,int asone,char *o);
int insertfl(char *filename,int icomma,int itab,int ispace,int idotcom,int other,int asone,char *o);
int nextline();
int add2matrix(char *word);
int addi2matrix(int v);
int addd2matrix(double v);
int makesortd();
int makesorta();
int makebrush();
int setbrsh(Cell *cell);
int incr();
#endif /* MAIN_H */
