/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef MODULE_H
#define MODULE_H
#include <stdio.h>
#include <stdlib.h>
#include "gram_ext.h"
#include "interpret.h"

typedef struct 
{ nodeType* tree;
  char ** sourcecode; /* xxx line of code */
  int     nlc;
  char     ** entrylabel;
  nodeType ** entrynode;
  int nentries;
  int declared;
} Module;

extern Module * new_module ();
extern int freemodule ();
extern int module_nfile( Module* module, char* filename);
extern int module_freecode( Module* module);
extern Module *ActivateModule (Module * module);
extern int module_declare (Module* module);
extern int emitlabel(nodeType *p) ;
extern int module_s(Module * module,FILE* fp);
#endif /* MODULE_H */
