/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#include "printdialog.h"
#include "inputbox.h"
#include "widget_makerX11.h"
#include "main.h"

Widget tofile;

void
X11m_print ()
{
  display_prompt (td3, gettop ());
}

void
doprint ()
{
  char *filename = NULL;
  int print2file = getcheck (tofile);
  if (print2file)
    filename = inputbox ("File name:", "Print to File", "output.fig");
  printfl (filename);
}

void
initprintdial ()
{

}

int
make_print_dial ()
{

  Widget base;

  td3 = CreateThumbDialog (gettop (), XtNumber (printpane), printpane, doprint, initprintdial);

  base = get_base (td3);

  addpanechild (td3, 0, CreateLabel (base, "Print to File", 20, 35, 160, 20));
  w_n = 0;
  w_rel (NULL, 190, 35);
  tofile = (Widget) make_check (base, "to file", NULL, (XtPointer) td3);
  w_set (tofile);
  setcheck (tofile, 0);
  addpanechild (td3, 0, tofile);
  addpanechild (td3, 0, CreateLabel (base, "Under Construction...", 30, 80, 350, 20));
  addpanechild (td3, 0, CreateLabel (base, "Print to file generate a fig format file", 30, 100, 350, 20));
  addpanechild (td3, 0, CreateLabel (base, "  > Use xfig to preview and print output.fig", 30, 120, 350, 20));
  addpanechild (td3, 0, CreateLabel (base, "  > Or use transfig to convert to postscript", 30, 140, 350, 20));
  addpanechild (td3, 0, CreateLabel (base, "Else Print use fig2dev, lpr and the default queue", 30, 160, 350, 20));

  activepane (td3, 0);
  return 0;
}
