/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef PROPERTIES_H
#define PROPERTIES_H
#include "libfct.h"
#include "chart_vb.h"
#include "worksheet_vb.h"
#include "cell_vb.h"



typedef struct
{ char* name;
  int type;
  obj (*setfct) ();
  obj (*getfct) ();
} Property;


static Property properties [] =
{ {"ActiveChart",      CHART,    NULL,      &vb_g_ActiveChart      }, 
  {"ActiveWorksheet",  WORKSHEET,NULL,  &vb_g_ActiveWorksheet  }, 
  {"ActiveCell",   CELL, NULL,   &vb_g_ActiveCell   }, 
  {"ChartObjects",   CELL, NULL,   &vb_g_tempchartobjects   }, 
  {"ActiveSheet",  WORKSHEET,NULL,  &vb_g_ActiveWorksheet  }, 
  {"Selection",  RANGE,NULL,  &vb_g_Selection  }, 
  {"Worksheets",  WORKSHEETS,NULL,  &vb_g_Worksheets  }, 
  {"Workbooks",  WORKBOOKS,NULL,  &vb_g_Workbooks  }, 
  {NULL,     0   ,NULL,NULL}
};
  

extern obj property2obj (obj o);
extern obj check4property (obj o);


#endif /* PROPERTIES_H*/
