/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#include "selection.h"
#include "range.h"
#include "memory.h"

#define RANGE 10

Selection *ActiveSelection;

Selection *
newselection ()
{
  Selection *sel;
  sel = (Selection *) absmalloc (sizeof (Selection), "newselection:sel ");
  sel->objects = NULL;
  sel->otyp = NULL;
  sel->objn = 0;
  return sel;
}

int
freeselection (sel)
     Selection *sel;
{
  if (sel == NULL)
    return 1;
  if (sel->objects != NULL)
    absfree (sel->objects, "freeselection:sel->objects ");
  if (sel->otyp != NULL)
    absfree (sel->otyp, "freeselection:sel->otyp ");
  absfree (sel, "freeselection:sel ");
  return 0;
}

int
selection_addobj (sel, obj, type)
     Selection *sel;
     char *obj;
     int type;
{
  sel->objn++;
  sel->objects = (char **) absrealloc (sel->objects, sel->objn * sizeof (char *), "selection_addobj:sel->objects ");
  sel->otyp = (int *) absrealloc (sel->objects, sel->objn * sizeof (int), "selection_addobj:sel->otyp ");
  return 0;
}

int
selection_reset (sel)
     Selection *sel;
{
  int i;
  for (i = 0; i < sel->objn; i++)
    if (sel->otyp[i] == RANGE)
      freerange ((Range *) sel->objects[i]);

  if (sel->objects != NULL)
    absfree (sel->objects, "selection_reset:sel->objects ");
  if (sel->otyp != NULL)
    absfree (sel->otyp, "selection_reset:sel->otyp ");
  sel->objects = NULL;
  sel->otyp = NULL;
  sel->objn = 0;
  return 0;
}
