/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef STATFCT_H
#define STATFCT_H
#include "object.h"
#include "libfct.h"


extern obj vb_AVEDEV (int narg, obj* arg);
extern obj vb_AVERAGE (int narg, obj* arg);
extern obj vb_BETADIST (int narg, obj* arg);
extern obj vb_BETAINV (int narg, obj* arg);
extern obj vb_BINOMDIST (int narg, obj* arg);
extern obj vb_CHIDIST (int narg, obj* arg);
extern obj vb_CHIINV (int narg, obj* arg);
extern obj vb_CHITEST (int narg, obj* arg);
extern obj vb_CONFIDENCE (int narg, obj* arg);
extern obj vb_CORREL (int narg, obj* arg);
extern obj vb_COUNT (int narg, obj* arg);
extern obj vb_COUNTA (int narg, obj* arg);
extern obj vb_COVAR (int narg, obj* arg);
extern obj vb_CRITBINOM (int narg, obj* arg);
extern obj vb_DEVSQ (int narg, obj* arg);
extern obj vb_EXPONDIST (int narg, obj* arg);
extern obj vb_FDIST (int narg, obj* arg);
extern obj vb_FINV (int narg, obj* arg);
extern obj vb_FISHER (int narg, obj* arg);
extern obj vb_FISHERINV (int narg, obj* arg);
extern obj vb_FORECAST (int narg, obj* arg);
extern obj vb_FREQUENCY (int narg, obj* arg);
extern obj vb_FTEST (int narg, obj* arg);
extern obj vb_GAMMADIST (int narg, obj* arg);
extern obj vb_GAMMAINV (int narg, obj* arg);
extern obj vb_GAMMALN (int narg, obj* arg);
extern obj vb_GEOMEAN (int narg, obj* arg);
extern obj vb_GROWTH (int narg, obj* arg);
extern obj vb_HARMEAN (int narg, obj* arg);
extern obj vb_HYPGEOMDIST (int narg, obj* arg);
extern obj vb_INTERCEPT (int narg, obj* arg);
extern obj vb_KURT (int narg, obj* arg);
extern obj vb_LARGE (int narg, obj* arg);
extern obj vb_LINEST (int narg, obj* arg);
extern obj vb_LOGEST (int narg, obj* arg);
extern obj vb_LOGINV (int narg, obj* arg);
extern obj vb_LOGNORMDIST (int narg, obj* arg);
extern obj vb_MAX (int narg, obj* arg);
extern obj vb_MEDIAN (int narg, obj* arg);
extern obj vb_MIN (int narg, obj* arg);
extern obj vb_MODE (int narg, obj* arg);
extern obj vb_NEGBINOMDIST (int narg, obj* arg);
extern obj vb_NORMDIST (int narg, obj* arg);
extern obj vb_NORMINV (int narg, obj* arg);
extern obj vb_NORMSDIST (int narg, obj* arg);
extern obj vb_NORMSINV (int narg, obj* arg);
extern obj vb_PEARSON (int narg, obj* arg);
extern obj vb_PERCENTILE (int narg, obj* arg);
extern obj vb_PERCENTRANK (int narg, obj* arg);
extern obj vb_PERMUT (int narg, obj* arg);
extern obj vb_POISSON (int narg, obj* arg);
extern obj vb_PROB (int narg, obj* arg);
extern obj vb_QUARTILE (int narg, obj* arg);
extern obj vb_RANK (int narg, obj* arg);
extern obj vb_RSQ (int narg, obj* arg);
extern obj vb_SKEW (int narg, obj* arg);
extern obj vb_SLOPE (int narg, obj* arg);
extern obj vb_SMALL (int narg, obj* arg);
extern obj vb_STANDARDIZE (int narg, obj* arg);
extern obj vb_STDEV (int narg, obj* arg);
extern obj vb_STDEVP (int narg, obj* arg);
extern obj vb_STEYX (int narg, obj* arg);
extern obj vb_TDIST (int narg, obj* arg);
extern obj vb_TINV (int narg, obj* arg);
extern obj vb_TREND (int narg, obj* arg);
extern obj vb_TRIMMEAN (int narg, obj* arg);
extern obj vb_TTEST (int narg, obj* arg);
extern obj vb_VAR (int narg, obj* arg);
extern obj vb_VARP (int narg, obj* arg);
extern obj vb_WEIBULL (int narg, obj* arg);
extern obj vb_ZTEST (int narg, obj* arg);

extern Fct statmatrixfct[];
/*
AVEDEV                   Returns the average of the absolute deviations of data points from their                  mean 
 AVERAGE                   Returns the average of its arguments 
 BETADIST                   Returns the cumulative beta probability density function 
 BETAINV                   Returns the inverse of the cumulative beta probability density function 
 BINOMDIST                   Returns the individual term binomial distribution probability 
 CHIDIST                   Returns the one-tailed probability of the chi-squared distribution 
 CHIINV                   Returns the inverse of the one-tailed probability of the chi-squared                 distribution 
 CHITEST                   Returns the test for independence 
 CONFIDENCE                   Returns the confidence interval for a population mean 
 CORREL                   Returns the correlation coefficient between two data sets 
 COUNT                   Counts how many numbers are in the list of arguments 
 COUNTA                   Counts how many values are in the list of arguments 
 COVAR                   Returns covariance, the average of the products of paired deviations 
 CRITBINOM                   Returns the smallest value for which the cumulative binomial distribution is                   less than or equal to a criterion value 
 DEVSQ                   Returns the sum of squares of deviations 
 EXPONDIST                   Returns the exponential distribution 
 FDIST                   Returns the F probability distribution 
 FINV                   Returns the inverse of the F probability distribution 
 FISHER                   Returns the Fisher transformation 
 FISHERINV                   Returns the inverse of the Fisher transformation 
 FORECAST                   Returns a value along a linear trend 
 FREQUENCY                   Returns a frequency distribution as a vertical matrix 
 FTEST                   Returns the result of an F-test 
 GAMMADIST                   Returns the gamma distribution 
 GAMMAINV                   Returns the inverse of the gamma cumulative distribution 
 GAMMALN                   Returns the natural logarithm of the gamma function, G(x) 
 GEOMEAN                   Returns the geometric mean 
 GROWTH                   Returns values along an exponential trend 
 HARMEAN                   Returns the harmonic mean 
 HYPGEOMDIST                   Returns the hypergeometric distribution 
 INTERCEPT                   Returns the intercept of the linear regression line 
 KURT                   Returns the kurtosis of a data set 
 LARGE                   Returns the k-th largest value in a data set 
 LINEST                   Returns the parameters of a linear trend 
 LOGEST                   Returns the parameters of an exponential trend 
 LOGINV                   Returns the inverse of the lognormal distribution 
 LOGNORMDIST                   Returns the cumulative lognormal distribution 
 MAX                   Returns the maximum value in a list of arguments 
 MEDIAN                   Returns the median of the given numbers 
 MIN                   Returns the minimum value in a list of arguments 
 MODE                   Returns the most common value in a data set 
 NEGBINOMDIST                   Returns the negative binomial distribution 
 NORMDIST                   Returns the normal cumulative distribution 
 NORMINV                   Returns the inverse of the normal cumulative distribution 
 NORMSDIST                   Returns the standard normal cumulative distribution 
 NORMSINV                   Returns the inverse of the standard normal cumulative distribution 
 PEARSON                   Returns the Pearson product moment correlation coefficient 
 PERCENTILE                   Returns the k-th percentile of values in a range 
 PERCENTRANK                   Returns the percentage rank of a value in a data set 
 PERMUT                   Returns the number of permutations for a given number of objects 
 POISSON                   Returns the Poisson distribution 
 PROB                   Returns the probability that values in a range are between two limits 
 QUARTILE                   Returns the quartile of a data set 
 RANK                   Returns the rank of a number in a list of numbers 
 RSQ                   Returns the square of the Pearson product moment correlation coefficient 
 SKEW                   Returns the skewness of a distribution 
 SLOPE                   Returns the slope of the linear regression line 
 SMALL                   Returns the k-th smallest value in a data set 
 STANDARDIZE                   Returns a normalized value 
 STDEV                   Estimates standard deviation based on a sample 
 STDEVP                   Calculates standard deviation based on the entire population 
 STEYX                   Returns the standard error of the predicted y-value for each x in the                  regression 
 TDIST                   Returns the Student's t-distribution 
 TINV                   Returns the inverse of the Student's t-distribution 
 TREND                   Returns values along a linear trend 
 TRIMMEAN                   Returns the mean of the interior of a data set 
 TTEST                   Returns the probability associated with a Student's t-Test 
 VAR                   Estimates variance based on a sample 
 VARP                   Calculates variance based on the entire population 
 WEIBULL                   Returns the Weibull distribution 
 ZTEST                   Returns the two-tailed P-value of a z-test 
*/

#endif /* STATFCT_H*/
