/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#ifndef linT
static char sccsid[] = "@(#)65  1.2  src/gos/2d/XTOP/clients/xedit/util.c, xsample, gos420, 9613T 6/18/92 14:22:10";
#endif

#if (!defined(lint) && !defined(SABER))
static char Xrcsid[] = "$XConsortium: util.c,v 1.14 89/10/07 14:59:43 kit Exp $";
#endif

#include <stdio.h>
#include "xedit.h"

#include <X11/Xos.h>
#include <sys/stat.h>

extern Widget messwidget;

void
XeditPrintf (str)
     char *str;
{
  XawTextBlock text;
  static XawTextPosition pos = 0;

  text.length = strlen (str);
  text.ptr = str;
  text.firstPos = 0;
  text.format = FMT8BIT;

  XawTextReplace (messwidget, pos, pos, &text);

  pos += text.length;
  XawTextSetInsertionPoint (messwidget, pos);
}

Widget
MakeCommandButton (box, name, function)
     Widget box;
     char *name;
     XtCallbackProc function;
{
  Widget w = XtCreateManagedWidget (name, commandWidgetClass, box, NULL, ZERO);
  if (function != NULL)
    XtAddCallback (w, XtNcallback, function, (XtPointer) NULL);
  return w;
}

Widget
MakeStringBox (parent, name, string)
     Widget parent;
     String name, string;
{
  Arg args[5];
  Cardinal numargs = 0;
  Widget StringW;

  XtSetArg (args[numargs], XtNeditType, XawtextEdit);
  numargs++;
  XtSetArg (args[numargs], XtNstring, string);
  numargs++;

  StringW = XtCreateManagedWidget (name, asciiTextWidgetClass,
				   parent, args, numargs);
  return (StringW);
}

String
GetString (w)
     Widget w;
{
  String str;
  Arg arglist[1];

  XtSetArg (arglist[0], XtNstring, &str);
  XtGetValues (w, arglist, ONE);
  return (str);
}

FileAccess
MaybeCreateFile (file)
     char *file;
{
  Boolean exists;

  if (access (file, F_OK) != 0)
    creat (file, 0777);

  return (CheckFilePermissions (file, &exists));
}

FileAccess
CheckFilePermissions (file, exists)
     char *file;
     Boolean *exists;
{
  char temp[BUFSIZ], *ptr;

  if (access (file, F_OK) == 0)
    {
      *exists = TRUE;

      if (access (file, R_OK) != 0)
	return (NO_READ);

      if (access (file, R_OK | W_OK) == 0)
	return (WRITE_OK);
      return (READ_OK);
    }

  *exists = FALSE;

  strcpy (temp, file);
  if ((ptr = rindex (temp, '/')) == NULL)
    strcpy (temp, ".");
  else
    *ptr = '\0';

  if (access (temp, R_OK | W_OK | X_OK) == 0)
    return (WRITE_OK);
  return (NO_READ);
}
