/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/

#ifndef WORKBOOK_H
#define WORKBOOK_H
#include "worksheet.h"
#include "project.h"

typedef struct
{
 Worksheet **Worksheets;
 int nbworksheet;
 Worksheet *activeworksheet;
 Style *style;
 int objn;
 Project* project;
 char* name;
 int first_vis_wks;
} Workbook;

extern Workbook *ActiveWorkbook;

extern Workbook *newworkbook();
extern Workbook *
newworkbook1(int nbworksheet);
extern int freeworkbook();

extern Workbook *
workbook_o(char *filename);
extern int 
workbook_s(Workbook *doc, char *filename);

extern Workbook *
ActivateWorkbook(Workbook *wb);
extern Worksheet *
workbook_gsheet(Workbook *wb, char *name);
extern Worksheet *
workbook_gsheet2(Workbook *wb, int num);

extern Worksheet *
workbook_as(Workbook *wb, char *name);
extern Worksheet *
workbook_ds(Workbook *wb, int num);

extern int workbook_setnormalstyle(Workbook *workbook);
extern int workbook_calculate(Workbook *workbook);


#endif				/* WORKBOOK_H */
