/********************************************************************
This file is part of the abs 0.6a distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-1999  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: Andre.Bertin@ping.be
         http://www.ping.be/bertin/abs.shtml

*********************************************************************/


#ifndef lint
static char sccsid[] = "@(#)19  1.2  src/gos/2d/XTOP/clients/xedit/xedit.c, xsample, gos420, 9613T 6/18/92 14:22:27";
#endif

#include "xedit.h"
#include "../param.h"

static XtActionsRec actions[] =
{
  {"quit", DoQuit}
};

static Atom wm_delete_window;

Widget textwindow, messwidget, labelwindow, filenamewindow;

void ResetSourceChanged ();

static void makeButtonsAndBoxes ();

Display *CurDpy;

struct _app_resources app_resources;

#define Offset(field) XtOffsetOf(struct _app_resources, field)

static XtResource resources[] =
{
  {"enableBackups", "EnableBackups", XtRBoolean, sizeof (Boolean),
   Offset (enableBackups), XtRImmediate, FALSE},
  {"backupNamePrefix", "BackupNamePrefix", XtRString, sizeof (char *),
   Offset (backupNamePrefix), XtRString, ""},
  {"backupNameSuffix", "BackupNameSuffix", XtRString, sizeof (char *),
   Offset (backupNameSuffix), XtRString, ".BAK"}
};

#undef Offset

void
mainxedit (Widget top)
{
  CurDpy = XtDisplay (top);
  makeButtonsAndBoxes (top, NULL);
}

static void
makeButtonsAndBoxes (parent, filename)
     Widget parent;
     char *filename;
{
  Widget outer, b_row;
  Arg arglist[10];
  Cardinal num_args;

  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 600);
  num_args++;
  outer = XtCreateManagedWidget ("paned", formWidgetClass, parent,
				 arglist, num_args);

  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 60);
  num_args++;
  XtSetArg (arglist[num_args], XtNfromVert, NULL);
  num_args++;
  XtSetArg (arglist[num_args], XtNvertDistance, 0);
  num_args++;
  b_row = XtCreateManagedWidget ("buttons", boxWidgetClass, outer, arglist, num_args);
  {
    MakeCommandButton (b_row, "Close", DoQuit);
    MakeCommandButton (b_row, "Update", DoSave);
    MakeCommandButton (b_row, "Load", DoLoad);
    filenamewindow = MakeStringBox (b_row, "filename", filename);
  }
  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 20);
  num_args++;
  XtSetArg (arglist[num_args], XtNfromVert, b_row);
  num_args++;
  XtSetArg (arglist[num_args], XtNvertDistance, 0);
  num_args++;
  XtCreateManagedWidget ("bc_label", labelWidgetClass, outer, arglist, num_args);

  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 60);
  num_args++;
  XtSetArg (arglist[num_args], XtNfromVert, b_row);
  num_args++;
  XtSetArg (arglist[num_args], XtNvertDistance, 20);
  num_args++;
  XtSetArg (arglist[num_args], XtNeditType, XawtextEdit);
  num_args++;
  messwidget = XtCreateManagedWidget ("messageWindow", asciiTextWidgetClass,
				      outer, arglist, num_args);

  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 20);
  num_args++;
  XtSetArg (arglist[num_args], XtNfromVert, messwidget);
  num_args++;
  XtSetArg (arglist[num_args], XtNvertDistance, 0);
  num_args++;
  if (filename != NULL)
    {
      XtSetArg (arglist[num_args], XtNlabel, filename);
      num_args++;
    }

  labelwindow = XtCreateManagedWidget ("labelWindow", labelWidgetClass,
				       outer, arglist, num_args);

  num_args = 0;
  XtSetArg (arglist[num_args], XtNwidth, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNheight, 400);
  num_args++;
  XtSetArg (arglist[num_args], XtNfromVert, labelwindow);
  num_args++;
  XtSetArg (arglist[num_args], XtNvertDistance, 0);
  num_args++;
  XtSetArg (arglist[num_args], XtNtype, XawAsciiFile);
  num_args++;
  XtSetArg (arglist[num_args], XtNeditType, XawtextEdit);
  num_args++;
  textwindow = XtCreateManagedWidget ("editWindow", asciiTextWidgetClass,
				      outer, arglist, num_args);
  w_n = 0;
  w_bONw ();
  w_set (textwindow);

  if (filename != NULL)
    DoLoad ();
  else
    ResetSourceChanged (textwindow);
}

void
Feep ()
{
  XBell (CurDpy, 0);
}
